require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__KERNEL__)) {
    unless(defined(&__ASM_HARDIRQ_H)) {
	eval 'sub __ASM_HARDIRQ_H () {1;}' unless defined(&__ASM_HARDIRQ_H);
	require 'linux/config.ph';
	require 'asm/smp.ph';
	require 'linux/irq_cpustat.ph';
	eval 'sub last_jiffy_stamp {
	    my($cpu) = @_;
    	    eval q( &__IRQ_STAT(($cpu),  &__last_jiffy_stamp));
	}' unless defined(&last_jiffy_stamp);
	eval 'sub heartbeat_count {
	    my($cpu) = @_;
    	    eval q( &__IRQ_STAT(($cpu),  &__heartbeat_count));
	}' unless defined(&heartbeat_count);
	eval 'sub heartbeat_reset {
	    my($cpu) = @_;
    	    eval q( &__IRQ_STAT(($cpu),  &__heartbeat_reset));
	}' unless defined(&heartbeat_reset);
	eval 'sub in_interrupt () {
	    eval q(({ \'int\'  &__cpu =  &smp_processor_id(); ( &local_irq_count( &__cpu) +  &local_bh_count( &__cpu) != 0); }));
	}' unless defined(&in_interrupt);
	eval 'sub in_irq () {
	    eval q(( &local_irq_count( &smp_processor_id()) != 0));
	}' unless defined(&in_irq);
	unless(defined(&CONFIG_SMP)) {
	    eval 'sub hardirq_trylock {
	        my($cpu) = @_;
    		eval q(( &local_irq_count($cpu) == 0));
	    }' unless defined(&hardirq_trylock);
	    eval 'sub hardirq_endlock {
	        my($cpu) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&hardirq_endlock);
	    eval 'sub hardirq_enter {
	        my($cpu) = @_;
    		eval q(( &local_irq_count($cpu)++));
	    }' unless defined(&hardirq_enter);
	    eval 'sub hardirq_exit {
	        my($cpu) = @_;
    		eval q(( &local_irq_count($cpu)--));
	    }' unless defined(&hardirq_exit);
	    eval 'sub synchronize_irq () {
	        eval q( &do { }  &while (0));
	    }' unless defined(&synchronize_irq);
	} else {
	    require 'asm/atomic.ph';
	    eval 'sub release_irqlock {
	        my($cpu) = @_;
    		eval q({  &if ( &global_irq_holder == $cpu) {  &global_irq_holder =  &NO_PROC_ID;  &clear_bit(0, &global_irq_lock); } });
	    }' unless defined(&release_irqlock);
# some #ifdef were dropped here -- fill in the blanks
	    eval 'sub hardirq_enter {
	        my($cpu) = @_;
    		eval q({ my $loops = 10000000; ++ &local_irq_count($cpu);  &atomic_inc( &global_irq_count);  &while ( &test_bit(0, &global_irq_lock)) {  &if ($cpu ==  &global_irq_holder) {  &printk(\\"uh oh, interrupt while we hold global irq lock! (CPU %d)\\\\n\\", $cpu);  &break; }  &if ( $loops-- == 0) {  &printk(\\"do_IRQ waiting for irq lock (holder=%d)\\\\n\\",  &global_irq_holder); } } });
	    }' unless defined(&hardirq_enter);
	    eval 'sub hardirq_exit {
	        my($cpu) = @_;
    		eval q({  &atomic_dec( &global_irq_count); -- &local_irq_count($cpu); });
	    }' unless defined(&hardirq_exit);
	    eval 'sub hardirq_trylock {
	        my($cpu) = @_;
    		eval q({ ! &atomic_read( &global_irq_count)  && ! &test_bit(0, &global_irq_lock); });
	    }' unless defined(&hardirq_trylock);
	    eval 'sub hardirq_endlock {
	        my($cpu) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&hardirq_endlock);
	}
    }
}
1;
