require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__KERNEL__)) {
    unless(defined(&_PPC_IO_H)) {
	eval 'sub _PPC_IO_H () {1;}' unless defined(&_PPC_IO_H);
	require 'linux/config.ph';
	require 'linux/mm.ph';
	require 'linux/types.ph';
	require 'asm/mmu.ph';
	require 'asm/page.ph';
	require 'asm/byteorder.ph';
	eval 'sub SIO_CONFIG_RA () {0x398;}' unless defined(&SIO_CONFIG_RA);
	eval 'sub SIO_CONFIG_RD () {0x399;}' unless defined(&SIO_CONFIG_RD);
	eval 'sub SLOW_DOWN_IO () {1;}' unless defined(&SLOW_DOWN_IO);
	eval 'sub PMAC_ISA_MEM_BASE () {0;}' unless defined(&PMAC_ISA_MEM_BASE);
	eval 'sub PMAC_PCI_DRAM_OFFSET () {0;}' unless defined(&PMAC_PCI_DRAM_OFFSET);
	eval 'sub CHRP_ISA_IO_BASE () {0xf8000000;}' unless defined(&CHRP_ISA_IO_BASE);
	eval 'sub CHRP_ISA_MEM_BASE () {0xf7000000;}' unless defined(&CHRP_ISA_MEM_BASE);
	eval 'sub CHRP_PCI_DRAM_OFFSET () {0;}' unless defined(&CHRP_PCI_DRAM_OFFSET);
	eval 'sub PREP_ISA_IO_BASE () {0x80000000;}' unless defined(&PREP_ISA_IO_BASE);
	eval 'sub PREP_ISA_MEM_BASE () {0xc0000000;}' unless defined(&PREP_ISA_MEM_BASE);
	eval 'sub PREP_PCI_DRAM_OFFSET () {0x80000000;}' unless defined(&PREP_PCI_DRAM_OFFSET);
	if(defined( &CONFIG_40x)) {
	    require 'asm/ibm4xx.ph';
	}
 elsif(defined( &CONFIG_8xx)) {
	    require 'asm/mpc8xx.ph';
	}
 elsif(defined( &CONFIG_8260)) {
	    require 'asm/mpc8260.ph';
	}
 elsif(defined( &CONFIG_APUS)) {
	    eval 'sub _IO_BASE () {0;}' unless defined(&_IO_BASE);
	    eval 'sub _ISA_MEM_BASE () {0;}' unless defined(&_ISA_MEM_BASE);
	    eval 'sub PCI_DRAM_OFFSET () {0;}' unless defined(&PCI_DRAM_OFFSET);
	} else {
	    eval 'sub _IO_BASE () { &isa_io_base;}' unless defined(&_IO_BASE);
	    eval 'sub _ISA_MEM_BASE () { &isa_mem_base;}' unless defined(&_ISA_MEM_BASE);
	    eval 'sub PCI_DRAM_OFFSET () { &pci_dram_offset;}' unless defined(&PCI_DRAM_OFFSET);
	}
	eval 'sub readb {
	    my($addr) = @_;
    	    eval q( &in_8(( &volatile  &u8 *)($addr)));
	}' unless defined(&readb);
	eval 'sub writeb {
	    my($b,$addr) = @_;
    	    eval q( &out_8(( &volatile  &u8 *)($addr), ($b)));
	}' unless defined(&writeb);
	if(defined( &CONFIG_APUS)) {
	    eval 'sub readw {
	        my($addr) = @_;
    		eval q((*( &volatile  &u16 *) ($addr)));
	    }' unless defined(&readw);
	    eval 'sub readl {
	        my($addr) = @_;
    		eval q((*( &volatile  &u32 *) ($addr)));
	    }' unless defined(&readl);
	    eval 'sub writew {
	        my($b,$addr) = @_;
    		eval q(((*( &volatile  &u16 *) ($addr)) = ($b)));
	    }' unless defined(&writew);
	    eval 'sub writel {
	        my($b,$addr) = @_;
    		eval q(((*( &volatile  &u32 *) ($addr)) = ($b)));
	    }' unless defined(&writel);
	} else {
	    eval 'sub readw {
	        my($addr) = @_;
    		eval q( &in_le16(( &volatile  &u16 *)($addr)));
	    }' unless defined(&readw);
	    eval 'sub readl {
	        my($addr) = @_;
    		eval q( &in_le32(( &volatile  &u32 *)($addr)));
	    }' unless defined(&readl);
	    eval 'sub writew {
	        my($b,$addr) = @_;
    		eval q( &out_le16(( &volatile  &u16 *)($addr),($b)));
	    }' unless defined(&writew);
	    eval 'sub writel {
	        my($b,$addr) = @_;
    		eval q( &out_le32(( &volatile  &u32 *)($addr),($b)));
	    }' unless defined(&writel);
	}
	eval 'sub __raw_readb {
	    my($addr) = @_;
    	    eval q((*( &volatile \'unsigned char\' *)($addr)));
	}' unless defined(&__raw_readb);
	eval 'sub __raw_readw {
	    my($addr) = @_;
    	    eval q((*( &volatile \'unsigned short\' *)($addr)));
	}' unless defined(&__raw_readw);
	eval 'sub __raw_readl {
	    my($addr) = @_;
    	    eval q((*( &volatile \'unsigned int\' *)($addr)));
	}' unless defined(&__raw_readl);
	eval 'sub __raw_writeb {
	    my($v, $addr) = @_;
    	    eval q((*( &volatile \'unsigned char\' *)($addr) = ($v)));
	}' unless defined(&__raw_writeb);
	eval 'sub __raw_writew {
	    my($v, $addr) = @_;
    	    eval q((*( &volatile \'unsigned short\' *)($addr) = ($v)));
	}' unless defined(&__raw_writew);
	eval 'sub __raw_writel {
	    my($v, $addr) = @_;
    	    eval q((*( &volatile \'unsigned int\' *)($addr) = ($v)));
	}' unless defined(&__raw_writel);
	eval 'sub insb {
	    my($port, $buf, $ns) = @_;
    	    eval q( &_insb(( &u8 *)(($port)+ &_IO_BASE), ($buf), ($ns)));
	}' unless defined(&insb);
	eval 'sub outsb {
	    my($port, $buf, $ns) = @_;
    	    eval q( &_outsb(( &u8 *)(($port)+ &_IO_BASE), ($buf), ($ns)));
	}' unless defined(&outsb);
	eval 'sub insw {
	    my($port, $buf, $ns) = @_;
    	    eval q( &_insw_ns(( &u16 *)(($port)+ &_IO_BASE), ($buf), ($ns)));
	}' unless defined(&insw);
	eval 'sub outsw {
	    my($port, $buf, $ns) = @_;
    	    eval q( &_outsw_ns(( &u16 *)(($port)+ &_IO_BASE), ($buf), ($ns)));
	}' unless defined(&outsw);
	eval 'sub insl {
	    my($port, $buf, $nl) = @_;
    	    eval q( &_insl_ns(( &u32 *)(($port)+ &_IO_BASE), ($buf), ($nl)));
	}' unless defined(&insl);
	eval 'sub outsl {
	    my($port, $buf, $nl) = @_;
    	    eval q( &_outsl_ns(( &u32 *)(($port)+ &_IO_BASE), ($buf), ($nl)));
	}' unless defined(&outsl);
	if(defined(&CONFIG_ALL_PPC)) {
	    eval 'sub __do_in_asm {
	        my($name, $op) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__do_in_asm);
	    eval 'sub __do_out_asm {
	        my($name, $op) = @_;
    		eval q(\\"(assembly code)\\");
	    }' unless defined(&__do_out_asm);
	}
 elsif(defined( &CONFIG_APUS)) {
	    eval 'sub inb {
	        my($port) = @_;
    		eval q( &in_8(( &u8 *)(($port)+ &_IO_BASE)));
	    }' unless defined(&inb);
	    eval 'sub outb {
	        my($val, $port) = @_;
    		eval q( &out_8(( &u8 *)(($port)+ &_IO_BASE), ($val)));
	    }' unless defined(&outb);
	    eval 'sub inw {
	        my($port) = @_;
    		eval q( &in_be16(( &u16 *)(($port)+ &_IO_BASE)));
	    }' unless defined(&inw);
	    eval 'sub outw {
	        my($val, $port) = @_;
    		eval q( &out_be16(( &u16 *)(($port)+ &_IO_BASE), ($val)));
	    }' unless defined(&outw);
	    eval 'sub inl {
	        my($port) = @_;
    		eval q( &in_be32(( &u32 *)(($port)+ &_IO_BASE)));
	    }' unless defined(&inl);
	    eval 'sub outl {
	        my($val, $port) = @_;
    		eval q( &out_be32(( &u32 *)(($port)+ &_IO_BASE), ($val)));
	    }' unless defined(&outl);
	} else {
	    eval 'sub inb {
	        my($port) = @_;
    		eval q( &in_8(( &u8 *)(($port)+ &_IO_BASE)));
	    }' unless defined(&inb);
	    eval 'sub outb {
	        my($val, $port) = @_;
    		eval q( &out_8(( &u8 *)(($port)+ &_IO_BASE), ($val)));
	    }' unless defined(&outb);
	    eval 'sub inw {
	        my($port) = @_;
    		eval q( &in_le16(( &u16 *)(($port)+ &_IO_BASE)));
	    }' unless defined(&inw);
	    eval 'sub outw {
	        my($val, $port) = @_;
    		eval q( &out_le16(( &u16 *)(($port)+ &_IO_BASE), ($val)));
	    }' unless defined(&outw);
	    eval 'sub inl {
	        my($port) = @_;
    		eval q( &in_le32(( &u32 *)(($port)+ &_IO_BASE)));
	    }' unless defined(&inl);
	    eval 'sub outl {
	        my($val, $port) = @_;
    		eval q( &out_le32(( &u32 *)(($port)+ &_IO_BASE), ($val)));
	    }' unless defined(&outl);
	}
	eval 'sub inb_p {
	    my($port) = @_;
    	    eval q( &inb(($port)));
	}' unless defined(&inb_p);
	eval 'sub outb_p {
	    my($val, $port) = @_;
    	    eval q( &outb(($val), ($port)));
	}' unless defined(&outb_p);
	eval 'sub inw_p {
	    my($port) = @_;
    	    eval q( &inw(($port)));
	}' unless defined(&inw_p);
	eval 'sub outw_p {
	    my($val, $port) = @_;
    	    eval q( &outw(($val), ($port)));
	}' unless defined(&outw_p);
	eval 'sub inl_p {
	    my($port) = @_;
    	    eval q( &inl(($port)));
	}' unless defined(&inl_p);
	eval 'sub outl_p {
	    my($val, $port) = @_;
    	    eval q( &outl(($val), ($port)));
	}' unless defined(&outl_p);
	eval 'sub insw_ns {
	    my($port, $buf, $ns) = @_;
    	    eval q( &_insw_ns(( &u16 *)(($port)+ &_IO_BASE), ($buf), ($ns)));
	}' unless defined(&insw_ns);
	eval 'sub outsw_ns {
	    my($port, $buf, $ns) = @_;
    	    eval q( &_outsw_ns(( &u16 *)(($port)+ &_IO_BASE), ($buf), ($ns)));
	}' unless defined(&outsw_ns);
	eval 'sub insl_ns {
	    my($port, $buf, $nl) = @_;
    	    eval q( &_insl_ns(( &u32 *)(($port)+ &_IO_BASE), ($buf), ($nl)));
	}' unless defined(&insl_ns);
	eval 'sub outsl_ns {
	    my($port, $buf, $nl) = @_;
    	    eval q( &_outsl_ns(( &u32 *)(($port)+ &_IO_BASE), ($buf), ($nl)));
	}' unless defined(&outsl_ns);
	eval 'sub IO_SPACE_LIMIT () {~0;}' unless defined(&IO_SPACE_LIMIT);
	eval 'sub memset_io {
	    my($a,$b,$c) = @_;
    	    eval q( &memset(( &void *)($a),($b),($c)));
	}' unless defined(&memset_io);
	eval 'sub memcpy_fromio {
	    my($a,$b,$c) = @_;
    	    eval q( &memcpy(($a),( &void *)($b),($c)));
	}' unless defined(&memcpy_fromio);
	eval 'sub memcpy_toio {
	    my($a,$b,$c) = @_;
    	    eval q( &memcpy(( &void *)($a),($b),($c)));
	}' unless defined(&memcpy_toio);
	eval 'sub ioremap_nocache {
	    my($addr, $size) = @_;
    	    eval q( &ioremap(($addr), ($size)));
	}' unless defined(&ioremap_nocache);
	eval 'sub page_to_phys {
	    my($page) = @_;
    	    eval q(((($page -  &mem_map) <<  &PAGE_SHIFT) +  &PPC_MEMSTART));
	}' unless defined(&page_to_phys);
	eval 'sub page_to_bus {
	    my($page) = @_;
    	    eval q(( &page_to_phys($page) +  &PCI_DRAM_OFFSET));
	}' unless defined(&page_to_bus);
	eval 'sub iobarrier_rw () {
	    eval q( &eieio());
	}' unless defined(&iobarrier_rw);
	eval 'sub iobarrier_r () {
	    eval q( &eieio());
	}' unless defined(&iobarrier_r);
	eval 'sub iobarrier_w () {
	    eval q( &eieio());
	}' unless defined(&iobarrier_w);
	if(defined(&CONFIG_NOT_COHERENT_CACHE)) {
	    eval 'sub dma_cache_inv {
	        my($_start,$_size) = @_;
    		eval q( &invalidate_dcache_range($_start, ($_start + $_size)));
	    }' unless defined(&dma_cache_inv);
	    eval 'sub dma_cache_wback {
	        my($_start,$_size) = @_;
    		eval q( &clean_dcache_range($_start, ($_start + $_size)));
	    }' unless defined(&dma_cache_wback);
	    eval 'sub dma_cache_wback_inv {
	        my($_start,$_size) = @_;
    		eval q( &flush_dcache_range($_start, ($_start + $_size)));
	    }' unless defined(&dma_cache_wback_inv);
	} else {
	    eval 'sub dma_cache_inv {
	        my($_start,$_size) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&dma_cache_inv);
	    eval 'sub dma_cache_wback {
	        my($_start,$_size) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&dma_cache_wback);
	    eval 'sub dma_cache_wback_inv {
	        my($_start,$_size) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&dma_cache_wback_inv);
	    eval 'sub consistent_alloc {
	        my($gfp, $size, $handle) = @_;
    		eval q( &NULL);
	    }' unless defined(&consistent_alloc);
	    eval 'sub consistent_free {
	        my($addr, $size) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&consistent_free);
	    eval 'sub consistent_sync {
	        my($addr, $size, $rw) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&consistent_sync);
	    eval 'sub consistent_sync_page {
	        my($pg, $off, $sz, $rw) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&consistent_sync_page);
	}
    }
}
1;
