require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__KERNEL__)) {
    unless(defined(&_ASM_IRQ_H)) {
	eval 'sub _ASM_IRQ_H () {1;}' unless defined(&_ASM_IRQ_H);
	require 'linux/config.ph';
	require 'asm/machdep.ph';
	require 'asm/atomic.ph';
	eval 'sub IRQ_SENSE_MASK () {0x1;}' unless defined(&IRQ_SENSE_MASK);
	eval 'sub IRQ_SENSE_LEVEL () {0x1;}' unless defined(&IRQ_SENSE_LEVEL);
	eval 'sub IRQ_SENSE_EDGE () {0x;}' unless defined(&IRQ_SENSE_EDGE);
	eval 'sub IRQ_POLARITY_MASK () {0x2;}' unless defined(&IRQ_POLARITY_MASK);
	eval 'sub IRQ_POLARITY_POSITIVE () {0x2;}' unless defined(&IRQ_POLARITY_POSITIVE);
	eval 'sub IRQ_POLARITY_NEGATIVE () {0x;}' unless defined(&IRQ_POLARITY_NEGATIVE);
	if(defined( &CONFIG_40x)) {
	    require 'asm/ibm4xx.ph';
	    unless(defined(&NR_BOARD_IRQS)) {
		eval 'sub NR_BOARD_IRQS () {0;}' unless defined(&NR_BOARD_IRQS);
	    }
	    unless(defined(&UIC_WIDTH)) {
		eval 'sub UIC_WIDTH () {32;}' unless defined(&UIC_WIDTH);
	    }
	    unless(defined(&NR_UICS)) {
		eval 'sub NR_UICS () {1;}' unless defined(&NR_UICS);
	    }
	    if(defined ( &CONFIG_403)) {
		eval 'sub NR_AIC_IRQS () {32;}' unless defined(&NR_AIC_IRQS);
		eval 'sub NR_IRQS () {( &NR_AIC_IRQS +  &NR_BOARD_IRQS);}' unless defined(&NR_IRQS);
	    }
 elsif(!defined ( &CONFIG_403)) {
		eval 'sub NR_UIC_IRQS () { &UIC_WIDTH;}' unless defined(&NR_UIC_IRQS);
		eval 'sub NR_IRQS () {(( &NR_UIC_IRQS *  &NR_UICS) +  &NR_BOARD_IRQS);}' unless defined(&NR_IRQS);
	    }
	    eval 'sub irq_cannonicalize {
	        my($irq) = @_;
    		eval q({ ($irq); });
	    }' unless defined(&irq_cannonicalize);
	}
 elsif(defined( &CONFIG_44x)) {
	    require 'asm/ibm44x.ph';
	    eval 'sub NR_UIC_IRQS () {32;}' unless defined(&NR_UIC_IRQS);
	    eval 'sub NR_IRQS () {(( &NR_UIC_IRQS *  &NR_UICS) +  &NR_BOARD_IRQS);}' unless defined(&NR_IRQS);
	    eval 'sub irq_cannonicalize {
	        my($irq) = @_;
    		eval q({ ($irq); });
	    }' unless defined(&irq_cannonicalize);
	}
 elsif(defined( &CONFIG_8xx)) {
	    require 'asm/mpc8xx.ph';
	    eval 'sub NR_SIU_INTS () {16;}' unless defined(&NR_SIU_INTS);
	    eval 'sub NR_CPM_INTS () {32;}' unless defined(&NR_CPM_INTS);
	    unless(defined(&NR_8259_INTS)) {
		eval 'sub NR_8259_INTS () {0;}' unless defined(&NR_8259_INTS);
	    }
	    eval 'sub SIU_IRQ_OFFSET () {0;}' unless defined(&SIU_IRQ_OFFSET);
	    eval 'sub CPM_IRQ_OFFSET () {( &SIU_IRQ_OFFSET +  &NR_SIU_INTS);}' unless defined(&CPM_IRQ_OFFSET);
	    eval 'sub I8259_IRQ_OFFSET () {( &CPM_IRQ_OFFSET +  &NR_CPM_INTS);}' unless defined(&I8259_IRQ_OFFSET);
	    eval 'sub NR_IRQS () {( &NR_SIU_INTS +  &NR_CPM_INTS +  &NR_8259_INTS);}' unless defined(&NR_IRQS);
	    eval 'sub SIU_IRQ0 () {(0);}' unless defined(&SIU_IRQ0);
	    eval 'sub SIU_LEVEL0 () {(1);}' unless defined(&SIU_LEVEL0);
	    eval 'sub SIU_IRQ1 () {(2);}' unless defined(&SIU_IRQ1);
	    eval 'sub SIU_LEVEL1 () {(3);}' unless defined(&SIU_LEVEL1);
	    eval 'sub SIU_IRQ2 () {(4);}' unless defined(&SIU_IRQ2);
	    eval 'sub SIU_LEVEL2 () {(5);}' unless defined(&SIU_LEVEL2);
	    eval 'sub SIU_IRQ3 () {(6);}' unless defined(&SIU_IRQ3);
	    eval 'sub SIU_LEVEL3 () {(7);}' unless defined(&SIU_LEVEL3);
	    eval 'sub SIU_IRQ4 () {(8);}' unless defined(&SIU_IRQ4);
	    eval 'sub SIU_LEVEL4 () {(9);}' unless defined(&SIU_LEVEL4);
	    eval 'sub SIU_IRQ5 () {(10);}' unless defined(&SIU_IRQ5);
	    eval 'sub SIU_LEVEL5 () {(11);}' unless defined(&SIU_LEVEL5);
	    eval 'sub SIU_IRQ6 () {(12);}' unless defined(&SIU_IRQ6);
	    eval 'sub SIU_LEVEL6 () {(13);}' unless defined(&SIU_LEVEL6);
	    eval 'sub SIU_IRQ7 () {(14);}' unless defined(&SIU_IRQ7);
	    eval 'sub SIU_LEVEL7 () {(15);}' unless defined(&SIU_LEVEL7);
	    unless(defined(&PIT_INTERRUPT)) {
		eval 'sub PIT_INTERRUPT () { &SIU_LEVEL0;}' unless defined(&PIT_INTERRUPT);
	    }
	    unless(defined(&CPM_INTERRUPT)) {
		eval 'sub CPM_INTERRUPT () { &SIU_LEVEL2;}' unless defined(&CPM_INTERRUPT);
	    }
	    unless(defined(&PCMCIA_INTERRUPT)) {
		eval 'sub PCMCIA_INTERRUPT () { &SIU_LEVEL6;}' unless defined(&PCMCIA_INTERRUPT);
	    }
	    unless(defined(&DEC_INTERRUPT)) {
		eval 'sub DEC_INTERRUPT () { &SIU_LEVEL7;}' unless defined(&DEC_INTERRUPT);
	    }
	    eval 'sub mk_int_int_mask {
	        my($IL) = @_;
    		eval q((1<< (7- ($IL/2))));
	    }' unless defined(&mk_int_int_mask);
	} else {
	    eval 'sub NR_IRQS () {256;}' unless defined(&NR_IRQS);
	    unless(defined(&CONFIG_8260)) {
		eval 'sub NUM_8259_INTERRUPTS () {16;}' unless defined(&NUM_8259_INTERRUPTS);
	    } else {
		eval 'sub NR_SIU_INTS () {64;}' unless defined(&NR_SIU_INTS);
		eval 'sub SIU_INT_ERROR () {(0x);}' unless defined(&SIU_INT_ERROR);
		eval 'sub SIU_INT_I2C () {(0x1);}' unless defined(&SIU_INT_I2C);
		eval 'sub SIU_INT_SPI () {(0x2);}' unless defined(&SIU_INT_SPI);
		eval 'sub SIU_INT_RISC () {(0x3);}' unless defined(&SIU_INT_RISC);
		eval 'sub SIU_INT_SMC1 () {(0x4);}' unless defined(&SIU_INT_SMC1);
		eval 'sub SIU_INT_SMC2 () {(0x5);}' unless defined(&SIU_INT_SMC2);
		eval 'sub SIU_INT_IDMA1 () {(0x6);}' unless defined(&SIU_INT_IDMA1);
		eval 'sub SIU_INT_IDMA2 () {(0x7);}' unless defined(&SIU_INT_IDMA2);
		eval 'sub SIU_INT_IDMA3 () {(0x8);}' unless defined(&SIU_INT_IDMA3);
		eval 'sub SIU_INT_IDMA4 () {(0x9);}' unless defined(&SIU_INT_IDMA4);
		eval 'sub SIU_INT_SDMA () {(0xa);}' unless defined(&SIU_INT_SDMA);
		eval 'sub SIU_INT_TIMER1 () {(0xc);}' unless defined(&SIU_INT_TIMER1);
		eval 'sub SIU_INT_TIMER2 () {(0xd);}' unless defined(&SIU_INT_TIMER2);
		eval 'sub SIU_INT_TIMER3 () {(0xe);}' unless defined(&SIU_INT_TIMER3);
		eval 'sub SIU_INT_TIMER4 () {(0xf);}' unless defined(&SIU_INT_TIMER4);
		eval 'sub SIU_INT_TMCNT () {(0x10);}' unless defined(&SIU_INT_TMCNT);
		eval 'sub SIU_INT_PIT () {(0x11);}' unless defined(&SIU_INT_PIT);
		eval 'sub SIU_INT_IRQ1 () {(0x13);}' unless defined(&SIU_INT_IRQ1);
		eval 'sub SIU_INT_IRQ2 () {(0x14);}' unless defined(&SIU_INT_IRQ2);
		eval 'sub SIU_INT_IRQ3 () {(0x15);}' unless defined(&SIU_INT_IRQ3);
		eval 'sub SIU_INT_IRQ4 () {(0x16);}' unless defined(&SIU_INT_IRQ4);
		eval 'sub SIU_INT_IRQ5 () {(0x17);}' unless defined(&SIU_INT_IRQ5);
		eval 'sub SIU_INT_IRQ6 () {(0x18);}' unless defined(&SIU_INT_IRQ6);
		eval 'sub SIU_INT_IRQ7 () {(0x19);}' unless defined(&SIU_INT_IRQ7);
		eval 'sub SIU_INT_FCC1 () {(0x20);}' unless defined(&SIU_INT_FCC1);
		eval 'sub SIU_INT_FCC2 () {(0x21);}' unless defined(&SIU_INT_FCC2);
		eval 'sub SIU_INT_FCC3 () {(0x22);}' unless defined(&SIU_INT_FCC3);
		eval 'sub SIU_INT_MCC1 () {(0x24);}' unless defined(&SIU_INT_MCC1);
		eval 'sub SIU_INT_MCC2 () {(0x25);}' unless defined(&SIU_INT_MCC2);
		eval 'sub SIU_INT_SCC1 () {(0x28);}' unless defined(&SIU_INT_SCC1);
		eval 'sub SIU_INT_SCC2 () {(0x29);}' unless defined(&SIU_INT_SCC2);
		eval 'sub SIU_INT_SCC3 () {(0x2a);}' unless defined(&SIU_INT_SCC3);
		eval 'sub SIU_INT_SCC4 () {(0x2b);}' unless defined(&SIU_INT_SCC4);
		eval 'sub SIU_INT_PC15 () {(0x30);}' unless defined(&SIU_INT_PC15);
		eval 'sub SIU_INT_PC14 () {(0x31);}' unless defined(&SIU_INT_PC14);
		eval 'sub SIU_INT_PC13 () {(0x32);}' unless defined(&SIU_INT_PC13);
		eval 'sub SIU_INT_PC12 () {(0x33);}' unless defined(&SIU_INT_PC12);
		eval 'sub SIU_INT_PC11 () {(0x34);}' unless defined(&SIU_INT_PC11);
		eval 'sub SIU_INT_PC10 () {(0x35);}' unless defined(&SIU_INT_PC10);
		eval 'sub SIU_INT_PC9 () {(0x36);}' unless defined(&SIU_INT_PC9);
		eval 'sub SIU_INT_PC8 () {(0x37);}' unless defined(&SIU_INT_PC8);
		eval 'sub SIU_INT_PC7 () {(0x38);}' unless defined(&SIU_INT_PC7);
		eval 'sub SIU_INT_PC6 () {(0x39);}' unless defined(&SIU_INT_PC6);
		eval 'sub SIU_INT_PC5 () {(0x3a);}' unless defined(&SIU_INT_PC5);
		eval 'sub SIU_INT_PC4 () {(0x3b);}' unless defined(&SIU_INT_PC4);
		eval 'sub SIU_INT_PC3 () {(0x3c);}' unless defined(&SIU_INT_PC3);
		eval 'sub SIU_INT_PC2 () {(0x3d);}' unless defined(&SIU_INT_PC2);
		eval 'sub SIU_INT_PC1 () {(0x3e);}' unless defined(&SIU_INT_PC1);
		eval 'sub SIU_INT_PC0 () {(0x3f);}' unless defined(&SIU_INT_PC0);
	    }
	}
	eval 'sub NR_MASK_WORDS () {(( &NR_IRQS + 31) / 32);}' unless defined(&NR_MASK_WORDS);
    }
}
1;
