require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__KERNEL__)) {
    unless(defined(&_PPC_PGTABLE_H)) {
	eval 'sub _PPC_PGTABLE_H () {1;}' unless defined(&_PPC_PGTABLE_H);
	require 'linux/config.ph';
	unless(defined(&__ASSEMBLY__)) {
	    require 'linux/sched.ph';
	    require 'linux/threads.ph';
	    require 'asm/processor.ph';
	    require 'asm/mmu.ph';
	    require 'asm/page.ph';
	    if(defined(&CONFIG_4xx)) {
		if(defined(&CONFIG_PIN_TLB)) {
		    eval 'sub __tlbia () {
		        eval q( &_tlbia());
		    }' unless defined(&__tlbia);
		} else {
		    eval 'sub __tlbia () {
		        eval q( &asm  &volatile (\\"tlbia; sync\\" : : : \\"memory\\"));
		    }' unless defined(&__tlbia);
		}
		eval 'sub update_mmu_cache {
		    my($vma, $addr, $pte) = @_;
    		    eval q( &do { }  &while (0));
		}' unless defined(&update_mmu_cache);
	    }
 elsif(defined( &CONFIG_8xx)) {
		eval 'sub __tlbia () {
		    eval q( &asm  &volatile (\\"tlbia; sync\\" : : : \\"memory\\"));
		}' unless defined(&__tlbia);
		eval 'sub update_mmu_cache {
		    my($vma, $addr, $pte) = @_;
    		    eval q( &do { }  &while (0));
		}' unless defined(&update_mmu_cache);
	    } else {
	    }
	    eval 'sub flush_tlb_all () { &local_flush_tlb_all;}' unless defined(&flush_tlb_all);
	    eval 'sub flush_tlb_mm () { &local_flush_tlb_mm;}' unless defined(&flush_tlb_mm);
	    eval 'sub flush_tlb_page () { &local_flush_tlb_page;}' unless defined(&flush_tlb_page);
	    eval 'sub flush_tlb_range () { &local_flush_tlb_range;}' unless defined(&flush_tlb_range);
	    eval 'sub flush_cache_all () {
	        eval q( &do { }  &while (0));
	    }' unless defined(&flush_cache_all);
	    eval 'sub flush_cache_mm {
	        my($mm) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_cache_mm);
	    eval 'sub flush_cache_range {
	        my($mm, $a, $b) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_cache_range);
	    eval 'sub flush_cache_page {
	        my($vma, $p) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_cache_page);
	    eval 'sub flush_page_to_ram {
	        my($page) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&flush_page_to_ram);
	    eval 'sub VMALLOC_START () { &vmalloc_start;}' unless defined(&VMALLOC_START);
	    eval 'sub VMALLOC_END () { &ioremap_bot;}' unless defined(&VMALLOC_END);
	    eval 'sub VMALLOC_VMADDR {
	        my($x) = @_;
    		eval q((($x)));
	    }' unless defined(&VMALLOC_VMADDR);
	}
	eval 'sub PMD_SHIFT () {( &PAGE_SHIFT +  &PTE_SHIFT);}' unless defined(&PMD_SHIFT);
	eval 'sub PMD_SIZE () {(1 <<  &PMD_SHIFT);}' unless defined(&PMD_SIZE);
	eval 'sub PMD_MASK () {(~( &PMD_SIZE-1));}' unless defined(&PMD_MASK);
	eval 'sub PGDIR_SHIFT () { &PMD_SHIFT;}' unless defined(&PGDIR_SHIFT);
	eval 'sub PGDIR_SIZE () {(1 <<  &PGDIR_SHIFT);}' unless defined(&PGDIR_SIZE);
	eval 'sub PGDIR_MASK () {(~( &PGDIR_SIZE-1));}' unless defined(&PGDIR_MASK);
	eval 'sub PTRS_PER_PTE () {(1<<  &PTE_SHIFT);}' unless defined(&PTRS_PER_PTE);
	eval 'sub PTRS_PER_PMD () {1;}' unless defined(&PTRS_PER_PMD);
	eval 'sub PTRS_PER_PGD () {(1<< (32-  &PGDIR_SHIFT));}' unless defined(&PTRS_PER_PGD);
	eval 'sub USER_PTRS_PER_PGD () {( &TASK_SIZE /  &PGDIR_SIZE);}' unless defined(&USER_PTRS_PER_PGD);
	eval 'sub FIRST_USER_PGD_NR () {0;}' unless defined(&FIRST_USER_PGD_NR);
	eval 'sub USER_PGD_PTRS () {( &PAGE_OFFSET >>  &PGDIR_SHIFT);}' unless defined(&USER_PGD_PTRS);
	eval 'sub KERNEL_PGD_PTRS () {( &PTRS_PER_PGD- &USER_PGD_PTRS);}' unless defined(&KERNEL_PGD_PTRS);
	eval 'sub pte_ERROR {
	    my($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pte \\" &PTE_FMT\\".\\\\n\\",  &__FILE__,  &__LINE__,  &pte_val($e)));
	}' unless defined(&pte_ERROR);
	eval 'sub pmd_ERROR {
	    my($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pmd %08lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pmd_val($e)));
	}' unless defined(&pmd_ERROR);
	eval 'sub pgd_ERROR {
	    my($e) = @_;
    	    eval q( &printk(\\"%s:%d: bad pgd %08lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pgd_val($e)));
	}' unless defined(&pgd_ERROR);
	if(defined( &CONFIG_40x)) {
	    eval 'sub _PAGE_GUARDED () {0x1;}' unless defined(&_PAGE_GUARDED);
	    eval 'sub _PAGE_PRESENT () {0x2;}' unless defined(&_PAGE_PRESENT);
	    eval 'sub _PAGE_NO_CACHE () {0x4;}' unless defined(&_PAGE_NO_CACHE);
	    eval 'sub _PAGE_WRITETHRU () {0x8;}' unless defined(&_PAGE_WRITETHRU);
	    eval 'sub _PAGE_USER () {0x10;}' unless defined(&_PAGE_USER);
	    eval 'sub _PAGE_RW () {0x40;}' unless defined(&_PAGE_RW);
	    eval 'sub _PAGE_DIRTY () {0x80;}' unless defined(&_PAGE_DIRTY);
	    eval 'sub _PAGE_HWWRITE () {0x100;}' unless defined(&_PAGE_HWWRITE);
	    eval 'sub _PAGE_HWEXEC () {0x200;}' unless defined(&_PAGE_HWEXEC);
	    eval 'sub _PAGE_ACCESSED () {0x400;}' unless defined(&_PAGE_ACCESSED);
	    eval 'sub _PMD_PRESENT () { &PAGE_MASK;}' unless defined(&_PMD_PRESENT);
	}
 elsif(defined( &CONFIG_44x)) {
	    eval 'sub _PAGE_PRESENT () {0x1;}' unless defined(&_PAGE_PRESENT);
	    eval 'sub _PAGE_RW () {0x2;}' unless defined(&_PAGE_RW);
	    eval 'sub _PAGE_DIRTY () {0x4;}' unless defined(&_PAGE_DIRTY);
	    eval 'sub _PAGE_ACCESSED () {0x8;}' unless defined(&_PAGE_ACCESSED);
	    eval 'sub _PAGE_HWWRITE () {0x10;}' unless defined(&_PAGE_HWWRITE);
	    eval 'sub _PAGE_HWEXEC () {0x20;}' unless defined(&_PAGE_HWEXEC);
	    eval 'sub _PAGE_USER () {0x40;}' unless defined(&_PAGE_USER);
	    eval 'sub _PAGE_ENDIAN () {0x80;}' unless defined(&_PAGE_ENDIAN);
	    eval 'sub _PAGE_GUARDED () {0x100;}' unless defined(&_PAGE_GUARDED);
	    eval 'sub _PAGE_COHERENT () {0x200;}' unless defined(&_PAGE_COHERENT);
	    eval 'sub _PAGE_FILE () {0x400;}' unless defined(&_PAGE_FILE);
	    eval 'sub _PAGE_NO_CACHE () {0x400;}' unless defined(&_PAGE_NO_CACHE);
	    eval 'sub _PAGE_WRITETHRU () {0x800;}' unless defined(&_PAGE_WRITETHRU);
	    eval 'sub _PMD_PRESENT () { &PAGE_MASK;}' unless defined(&_PMD_PRESENT);
	    eval 'sub _PMD_PRESENT_MASK () {( &PAGE_MASK);}' unless defined(&_PMD_PRESENT_MASK);
	    eval 'sub _PMD_BAD () {(~ &PAGE_MASK);}' unless defined(&_PMD_BAD);
	    eval 'sub _PTE_NONE_MASK () {1.84467440694146e+19;}' unless defined(&_PTE_NONE_MASK);
	}
 elsif(defined( &CONFIG_8xx)) {
	    eval 'sub _PAGE_PRESENT () {0x1;}' unless defined(&_PAGE_PRESENT);
	    eval 'sub _PAGE_NO_CACHE () {0x2;}' unless defined(&_PAGE_NO_CACHE);
	    eval 'sub _PAGE_SHARED () {0x4;}' unless defined(&_PAGE_SHARED);
	    eval 'sub _PAGE_EXEC () {0x8;}' unless defined(&_PAGE_EXEC);
	    eval 'sub _PAGE_GUARDED () {0x10;}' unless defined(&_PAGE_GUARDED);
	    eval 'sub _PAGE_DIRTY () {0x20;}' unless defined(&_PAGE_DIRTY);
	    eval 'sub _PAGE_RW () {0x40;}' unless defined(&_PAGE_RW);
	    eval 'sub _PAGE_ACCESSED () {0x80;}' unless defined(&_PAGE_ACCESSED);
	    eval 'sub _PAGE_HWWRITE () {0x100;}' unless defined(&_PAGE_HWWRITE);
	    eval 'sub _PAGE_USER () {0x800;}' unless defined(&_PAGE_USER);
	    eval 'sub _PMD_PRESENT () { &PAGE_MASK;}' unless defined(&_PMD_PRESENT);
	    eval 'sub _PMD_PAGE_MASK () {0xc;}' unless defined(&_PMD_PAGE_MASK);
	    eval 'sub _PMD_PAGE_8M () {0xc;}' unless defined(&_PMD_PAGE_8M);
	    eval 'sub _PTE_NONE_MASK () { &_PAGE_ACCESSED;}' unless defined(&_PTE_NONE_MASK);
	} else {
	    eval 'sub _PAGE_PRESENT () {0x1;}' unless defined(&_PAGE_PRESENT);
	    eval 'sub _PAGE_HASHPTE () {0x2;}' unless defined(&_PAGE_HASHPTE);
	    eval 'sub _PAGE_USER () {0x4;}' unless defined(&_PAGE_USER);
	    eval 'sub _PAGE_GUARDED () {0x8;}' unless defined(&_PAGE_GUARDED);
	    eval 'sub _PAGE_COHERENT () {0x10;}' unless defined(&_PAGE_COHERENT);
	    eval 'sub _PAGE_NO_CACHE () {0x20;}' unless defined(&_PAGE_NO_CACHE);
	    eval 'sub _PAGE_WRITETHRU () {0x40;}' unless defined(&_PAGE_WRITETHRU);
	    eval 'sub _PAGE_DIRTY () {0x80;}' unless defined(&_PAGE_DIRTY);
	    eval 'sub _PAGE_ACCESSED () {0x100;}' unless defined(&_PAGE_ACCESSED);
	    eval 'sub _PAGE_EXEC () {0x200;}' unless defined(&_PAGE_EXEC);
	    eval 'sub _PAGE_RW () {0x400;}' unless defined(&_PAGE_RW);
	    eval 'sub _PMD_PRESENT () { &PAGE_MASK;}' unless defined(&_PMD_PRESENT);
	    eval 'sub _PTE_NONE_MASK () { &_PAGE_HASHPTE;}' unless defined(&_PTE_NONE_MASK);
	}
	unless(defined(&_PAGE_HASHPTE)) {
	    eval 'sub _PAGE_HASHPTE () {0;}' unless defined(&_PAGE_HASHPTE);
	}
	unless(defined(&_PTE_NONE_MASK)) {
	    eval 'sub _PTE_NONE_MASK () {0;}' unless defined(&_PTE_NONE_MASK);
	}
	unless(defined(&_PAGE_SHARED)) {
	    eval 'sub _PAGE_SHARED () {0;}' unless defined(&_PAGE_SHARED);
	}
	unless(defined(&_PAGE_HWWRITE)) {
	    eval 'sub _PAGE_HWWRITE () {0;}' unless defined(&_PAGE_HWWRITE);
	}
	unless(defined(&_PAGE_HWEXEC)) {
	    eval 'sub _PAGE_HWEXEC () {0;}' unless defined(&_PAGE_HWEXEC);
	}
	unless(defined(&_PAGE_EXEC)) {
	    eval 'sub _PAGE_EXEC () {0;}' unless defined(&_PAGE_EXEC);
	}
	eval 'sub _PAGE_CHG_MASK () {( &PAGE_MASK |  &_PAGE_ACCESSED |  &_PAGE_DIRTY);}' unless defined(&_PAGE_CHG_MASK);
	eval 'sub _PAGE_BASE () { &_PAGE_PRESENT |  &_PAGE_ACCESSED;}' unless defined(&_PAGE_BASE);
	eval 'sub _PAGE_WRENABLE () { &_PAGE_RW |  &_PAGE_DIRTY |  &_PAGE_HWWRITE;}' unless defined(&_PAGE_WRENABLE);
	if(defined(&CONFIG_44x)) {
	    eval 'sub _PAGE_KERNEL () { &_PAGE_BASE |  &_PAGE_WRENABLE |  &_PAGE_SHARED |  &_PAGE_HWEXEC |  &_PAGE_GUARDED;}' unless defined(&_PAGE_KERNEL);
	} else {
	    eval 'sub _PAGE_KERNEL () { &_PAGE_BASE |  &_PAGE_WRENABLE |  &_PAGE_SHARED |  &_PAGE_HWEXEC;}' unless defined(&_PAGE_KERNEL);
	}
	eval 'sub _PAGE_IO () { &_PAGE_KERNEL |  &_PAGE_NO_CACHE |  &_PAGE_GUARDED;}' unless defined(&_PAGE_IO);
	eval 'sub PAGE_NONE () { &__pgprot( &_PAGE_BASE);}' unless defined(&PAGE_NONE);
	eval 'sub PAGE_READONLY () { &__pgprot( &_PAGE_BASE |  &_PAGE_USER);}' unless defined(&PAGE_READONLY);
	eval 'sub PAGE_READONLY_X () { &__pgprot( &_PAGE_BASE |  &_PAGE_USER |  &_PAGE_EXEC);}' unless defined(&PAGE_READONLY_X);
	eval 'sub PAGE_SHARED () { &__pgprot( &_PAGE_BASE |  &_PAGE_USER |  &_PAGE_RW);}' unless defined(&PAGE_SHARED);
	eval 'sub PAGE_SHARED_X () { &__pgprot( &_PAGE_BASE |  &_PAGE_USER |  &_PAGE_RW |  &_PAGE_EXEC);}' unless defined(&PAGE_SHARED_X);
	eval 'sub PAGE_COPY () { &__pgprot( &_PAGE_BASE |  &_PAGE_USER);}' unless defined(&PAGE_COPY);
	eval 'sub PAGE_COPY_X () { &__pgprot( &_PAGE_BASE |  &_PAGE_USER |  &_PAGE_EXEC);}' unless defined(&PAGE_COPY_X);
	eval 'sub PAGE_KERNEL () { &__pgprot( &_PAGE_KERNEL);}' unless defined(&PAGE_KERNEL);
	eval 'sub PAGE_KERNEL_RO () { &__pgprot( &_PAGE_BASE |  &_PAGE_SHARED);}' unless defined(&PAGE_KERNEL_RO);
	eval 'sub PAGE_KERNEL_CI () { &__pgprot( &_PAGE_IO);}' unless defined(&PAGE_KERNEL_CI);
	eval 'sub __P000 () { &PAGE_NONE;}' unless defined(&__P000);
	eval 'sub __P001 () { &PAGE_READONLY_X;}' unless defined(&__P001);
	eval 'sub __P010 () { &PAGE_COPY;}' unless defined(&__P010);
	eval 'sub __P011 () { &PAGE_COPY_X;}' unless defined(&__P011);
	eval 'sub __P100 () { &PAGE_READONLY;}' unless defined(&__P100);
	eval 'sub __P101 () { &PAGE_READONLY_X;}' unless defined(&__P101);
	eval 'sub __P110 () { &PAGE_COPY;}' unless defined(&__P110);
	eval 'sub __P111 () { &PAGE_COPY_X;}' unless defined(&__P111);
	eval 'sub __S000 () { &PAGE_NONE;}' unless defined(&__S000);
	eval 'sub __S001 () { &PAGE_READONLY_X;}' unless defined(&__S001);
	eval 'sub __S010 () { &PAGE_SHARED;}' unless defined(&__S010);
	eval 'sub __S011 () { &PAGE_SHARED_X;}' unless defined(&__S011);
	eval 'sub __S100 () { &PAGE_READONLY;}' unless defined(&__S100);
	eval 'sub __S101 () { &PAGE_READONLY_X;}' unless defined(&__S101);
	eval 'sub __S110 () { &PAGE_SHARED;}' unless defined(&__S110);
	eval 'sub __S111 () { &PAGE_SHARED_X;}' unless defined(&__S111);
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub ZERO_PAGE {
	        my($vaddr) = @_;
    		eval q(( &virt_to_page( &empty_zero_page)));
	    }' unless defined(&ZERO_PAGE);
	}
	eval 'sub pte_none {
	    my($pte) = @_;
    	    eval q((( &pte_val($pte) & ~ &_PTE_NONE_MASK) == 0));
	}' unless defined(&pte_none);
	eval 'sub pte_present {
	    my($pte) = @_;
    	    eval q(( &pte_val($pte) &  &_PAGE_PRESENT));
	}' unless defined(&pte_present);
	eval 'sub pte_clear {
	    my($ptep) = @_;
    	    eval q( &do {  &set_pte(($ptep),  &__pte(0)); }  &while (0));
	}' unless defined(&pte_clear);
	eval 'sub pmd_none {
	    my($pmd) = @_;
    	    eval q((! &pmd_val($pmd)));
	}' unless defined(&pmd_none);
	eval 'sub pmd_bad {
	    my($pmd) = @_;
    	    eval q((( &pmd_val($pmd) &  &_PMD_PRESENT) == 0));
	}' unless defined(&pmd_bad);
	eval 'sub pmd_present {
	    my($pmd) = @_;
    	    eval q((( &pmd_val($pmd) &  &_PMD_PRESENT) != 0));
	}' unless defined(&pmd_present);
	eval 'sub pmd_clear {
	    my($pmdp) = @_;
    	    eval q( &do {  &pmd_val(*($pmdp)) = 0; }  &while (0));
	}' unless defined(&pmd_clear);
	eval 'sub pte_page {
	    my($x) = @_;
    	    eval q(( &mem_map+(( &pte_val($x)- &PPC_MEMSTART) >>  &PAGE_SHIFT)));
	}' unless defined(&pte_page);
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub pgd_clear {
	        my($xp) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&pgd_clear);
	    eval 'sub pgd_page {
	        my($pgd) = @_;
    		eval q((  &__va( &pgd_val($pgd) &  &PAGE_MASK)));
	    }' unless defined(&pgd_page);
	    eval 'sub mk_pte {
	        my($page,$pgprot) = @_;
    		eval q(({  &pte_t  &pte;  &pte_val( &pte) = ((($page -  &mem_map) <<  &PAGE_SHIFT) +  &PPC_MEMSTART) |  &pgprot_val($pgprot);  &pte; }));
	    }' unless defined(&mk_pte);
	    eval 'sub pte_modify {
	        my($pte,$newprot) = @_;
    		eval q({  &pte_val($pte) = ( &pte_val($pte) &  &_PAGE_CHG_MASK) |  &pgprot_val($newprot); $pte; });
	    }' unless defined(&pte_modify);
	    if((defined(&_PAGE_HASHPTE) ? &_PAGE_HASHPTE : 0) != 0) {
	    } else {
	    }
	    eval 'sub ptep_test_and_clear_young {
	        my($ptep) = @_;
    		eval q({ ( &pte_update($ptep,  &_PAGE_ACCESSED, 0) &  &_PAGE_ACCESSED) != 0; });
	    }' unless defined(&ptep_test_and_clear_young);
	    eval 'sub ptep_test_and_clear_dirty {
	        my($ptep) = @_;
    		eval q({ ( &pte_update($ptep, ( &_PAGE_DIRTY |  &_PAGE_HWWRITE), 0) &  &_PAGE_DIRTY) != 0; });
	    }' unless defined(&ptep_test_and_clear_dirty);
	    eval 'sub ptep_get_and_clear {
	        my($ptep) = @_;
    		eval q({  &__pte( &pte_update($ptep, ~ &_PAGE_HASHPTE, 0)); });
	    }' unless defined(&ptep_get_and_clear);
	    eval 'sub ptep_set_wrprotect {
	        my($ptep) = @_;
    		eval q({  &pte_update($ptep, ( &_PAGE_RW |  &_PAGE_HWWRITE), 0); });
	    }' unless defined(&ptep_set_wrprotect);
	    eval 'sub ptep_mkdirty {
	        my($ptep) = @_;
    		eval q({  &pte_update($ptep, 0,  &_PAGE_DIRTY); });
	    }' unless defined(&ptep_mkdirty);
	    eval 'sub pte_same {
	        my($A,$B) = @_;
    		eval q(((( &pte_val($A) ^  &pte_val($B)) & ~ &_PAGE_HASHPTE) == 0));
	    }' unless defined(&pte_same);
	    eval 'sub pmd_page {
	        my($pmd) = @_;
    		eval q(( &pmd_val($pmd) &  &PAGE_MASK));
	    }' unless defined(&pmd_page);
	    eval 'sub pgd_offset_k {
	        my($address) = @_;
    		eval q( &pgd_offset( &init_mm, $address));
	    }' unless defined(&pgd_offset_k);
	    eval 'sub pgd_index {
	        my($address) = @_;
    		eval q((($address) >>  &PGDIR_SHIFT));
	    }' unless defined(&pgd_index);
	    eval 'sub pgd_offset {
	        my($mm, $address) = @_;
    		eval q((($mm)-> &pgd +  &pgd_index($address)));
	    }' unless defined(&pgd_offset);
	    eval 'sub SWP_TYPE {
	        my($entry) = @_;
    		eval q((($entry). &val & 0x3f));
	    }' unless defined(&SWP_TYPE);
	    eval 'sub SWP_OFFSET {
	        my($entry) = @_;
    		eval q((($entry). &val >> 6));
	    }' unless defined(&SWP_OFFSET);
	    eval 'sub SWP_ENTRY {
	        my($type, $offset) = @_;
    		eval q((( &swp_entry_t) { ($type) | (($offset) << 6) }));
	    }' unless defined(&SWP_ENTRY);
	    eval 'sub pte_to_swp_entry {
	        my($pte) = @_;
    		eval q((( &swp_entry_t) {  &pte_val($pte) >> 2}));
	    }' unless defined(&pte_to_swp_entry);
	    eval 'sub swp_entry_to_pte {
	        my($x) = @_;
    		eval q((( &pte_t) { ($x). &val << 2}));
	    }' unless defined(&swp_entry_to_pte);
	    eval 'sub IOMAP_FULL_CACHING () {0;}' unless defined(&IOMAP_FULL_CACHING);
	    eval 'sub IOMAP_NOCACHE_SER () {1;}' unless defined(&IOMAP_NOCACHE_SER);
	    eval 'sub IOMAP_NOCACHE_NONSER () {2;}' unless defined(&IOMAP_NOCACHE_NONSER);
	    eval 'sub IOMAP_NO_COPYBACK () {3;}' unless defined(&IOMAP_NO_COPYBACK);
	    eval 'sub kern_addr_valid {
	        my($addr) = @_;
    		eval q((1));
	    }' unless defined(&kern_addr_valid);
	    eval 'sub io_remap_page_range () { &remap_page_range;}' unless defined(&io_remap_page_range);
	    eval 'sub pgtable_cache_init () {
	        eval q( &do { }  &while (0));
	    }' unless defined(&pgtable_cache_init);
	}
    }
}
1;
