require '_h2ph_pre.ph';

no warnings 'redefine';

require 'linux/config.ph';
unless(defined(&SAVE_GPR)) {
    sub SAVE_GPR {
	my($n, $base) = @_;
	eval q( &stw $n, &GPR0+4*($n)($base));
    }
}
unless(defined(&SAVE_2GPRS)) {
    sub SAVE_2GPRS {
	my($n, $base) = @_;
	eval q( &SAVE_GPR($n, $base);  &SAVE_GPR($n+1, $base));
    }
}
unless(defined(&SAVE_4GPRS)) {
    sub SAVE_4GPRS {
	my($n, $base) = @_;
	eval q( &SAVE_2GPRS($n, $base);  &SAVE_2GPRS($n+2, $base));
    }
}
unless(defined(&SAVE_8GPRS)) {
    sub SAVE_8GPRS {
	my($n, $base) = @_;
	eval q( &SAVE_4GPRS($n, $base);  &SAVE_4GPRS($n+4, $base));
    }
}
unless(defined(&SAVE_10GPRS)) {
    sub SAVE_10GPRS {
	my($n, $base) = @_;
	eval q( &SAVE_8GPRS($n, $base);  &SAVE_2GPRS($n+8, $base));
    }
}
unless(defined(&REST_GPR)) {
    sub REST_GPR {
	my($n, $base) = @_;
	eval q( &lwz $n, &GPR0+4*($n)($base));
    }
}
unless(defined(&REST_2GPRS)) {
    sub REST_2GPRS {
	my($n, $base) = @_;
	eval q( &REST_GPR($n, $base);  &REST_GPR($n+1, $base));
    }
}
unless(defined(&REST_4GPRS)) {
    sub REST_4GPRS {
	my($n, $base) = @_;
	eval q( &REST_2GPRS($n, $base);  &REST_2GPRS($n+2, $base));
    }
}
unless(defined(&REST_8GPRS)) {
    sub REST_8GPRS {
	my($n, $base) = @_;
	eval q( &REST_4GPRS($n, $base);  &REST_4GPRS($n+4, $base));
    }
}
unless(defined(&REST_10GPRS)) {
    sub REST_10GPRS {
	my($n, $base) = @_;
	eval q( &REST_8GPRS($n, $base);  &REST_2GPRS($n+8, $base));
    }
}
unless(defined(&SAVE_FPR)) {
    sub SAVE_FPR {
	my($n, $base) = @_;
	eval q( &stfd $n, &THREAD_FPR0+8*($n)($base));
    }
}
unless(defined(&SAVE_2FPRS)) {
    sub SAVE_2FPRS {
	my($n, $base) = @_;
	eval q( &SAVE_FPR($n, $base);  &SAVE_FPR($n+1, $base));
    }
}
unless(defined(&SAVE_4FPRS)) {
    sub SAVE_4FPRS {
	my($n, $base) = @_;
	eval q( &SAVE_2FPRS($n, $base);  &SAVE_2FPRS($n+2, $base));
    }
}
unless(defined(&SAVE_8FPRS)) {
    sub SAVE_8FPRS {
	my($n, $base) = @_;
	eval q( &SAVE_4FPRS($n, $base);  &SAVE_4FPRS($n+4, $base));
    }
}
unless(defined(&SAVE_16FPRS)) {
    sub SAVE_16FPRS {
	my($n, $base) = @_;
	eval q( &SAVE_8FPRS($n, $base);  &SAVE_8FPRS($n+8, $base));
    }
}
unless(defined(&SAVE_32FPRS)) {
    sub SAVE_32FPRS {
	my($n, $base) = @_;
	eval q( &SAVE_16FPRS($n, $base);  &SAVE_16FPRS($n+16, $base));
    }
}
unless(defined(&REST_FPR)) {
    sub REST_FPR {
	my($n, $base) = @_;
	eval q( &lfd $n, &THREAD_FPR0+8*($n)($base));
    }
}
unless(defined(&REST_2FPRS)) {
    sub REST_2FPRS {
	my($n, $base) = @_;
	eval q( &REST_FPR($n, $base);  &REST_FPR($n+1, $base));
    }
}
unless(defined(&REST_4FPRS)) {
    sub REST_4FPRS {
	my($n, $base) = @_;
	eval q( &REST_2FPRS($n, $base);  &REST_2FPRS($n+2, $base));
    }
}
unless(defined(&REST_8FPRS)) {
    sub REST_8FPRS {
	my($n, $base) = @_;
	eval q( &REST_4FPRS($n, $base);  &REST_4FPRS($n+4, $base));
    }
}
unless(defined(&REST_16FPRS)) {
    sub REST_16FPRS {
	my($n, $base) = @_;
	eval q( &REST_8FPRS($n, $base);  &REST_8FPRS($n+8, $base));
    }
}
unless(defined(&REST_32FPRS)) {
    sub REST_32FPRS {
	my($n, $base) = @_;
	eval q( &REST_16FPRS($n, $base);  &REST_16FPRS($n+16, $base));
    }
}
unless(defined(&LVX)) {
    sub LVX {
	my($r,$a,$b) = @_;
	eval q(. &long (31<<26)+(($r)<<21)+(($a)<<16)+(($b)<<11)+(103<<1));
    }
}
unless(defined(&STVX)) {
    sub STVX {
	my($r,$a,$b) = @_;
	eval q(. &long (31<<26)+(($r)<<21)+(($a)<<16)+(($b)<<11)+(231<<1));
    }
}
unless(defined(&MFVSCR)) {
    sub MFVSCR {
	my($r) = @_;
	eval q(. &long (4<<26)+(($r)<<21)+(770<<1));
    }
}
unless(defined(&MTVSCR)) {
    sub MTVSCR {
	my($r) = @_;
	eval q(. &long (4<<26)+(($r)<<11)+(802<<1));
    }
}
unless(defined(&DSSALL)) {
    sub DSSALL () {	. &long (0x1f<<26)+(0x10<<21)+(0x336<<1);}
}
unless(defined(&SAVE_VR)) {
    sub SAVE_VR {
	my($n,$b,$base) = @_;
	eval q( &li $b, &THREAD_VR0+(16*($n));  &STVX($n,$b,$base));
    }
}
unless(defined(&SAVE_2VR)) {
    sub SAVE_2VR {
	my($n,$b,$base) = @_;
	eval q( &SAVE_VR($n,$b,$base);  &SAVE_VR($n+1,$b,$base));
    }
}
unless(defined(&SAVE_4VR)) {
    sub SAVE_4VR {
	my($n,$b,$base) = @_;
	eval q( &SAVE_2VR($n,$b,$base);  &SAVE_2VR($n+2,$b,$base));
    }
}
unless(defined(&SAVE_8VR)) {
    sub SAVE_8VR {
	my($n,$b,$base) = @_;
	eval q( &SAVE_4VR($n,$b,$base);  &SAVE_4VR($n+4,$b,$base));
    }
}
unless(defined(&SAVE_16VR)) {
    sub SAVE_16VR {
	my($n,$b,$base) = @_;
	eval q( &SAVE_8VR($n,$b,$base);  &SAVE_8VR($n+8,$b,$base));
    }
}
unless(defined(&SAVE_32VR)) {
    sub SAVE_32VR {
	my($n,$b,$base) = @_;
	eval q( &SAVE_16VR($n,$b,$base);  &SAVE_16VR($n+16,$b,$base));
    }
}
unless(defined(&REST_VR)) {
    sub REST_VR {
	my($n,$b,$base) = @_;
	eval q( &li $b, &THREAD_VR0+(16*($n));  &LVX($n,$b,$base));
    }
}
unless(defined(&REST_2VR)) {
    sub REST_2VR {
	my($n,$b,$base) = @_;
	eval q( &REST_VR($n,$b,$base);  &REST_VR($n+1,$b,$base));
    }
}
unless(defined(&REST_4VR)) {
    sub REST_4VR {
	my($n,$b,$base) = @_;
	eval q( &REST_2VR($n,$b,$base);  &REST_2VR($n+2,$b,$base));
    }
}
unless(defined(&REST_8VR)) {
    sub REST_8VR {
	my($n,$b,$base) = @_;
	eval q( &REST_4VR($n,$b,$base);  &REST_4VR($n+4,$b,$base));
    }
}
unless(defined(&REST_16VR)) {
    sub REST_16VR {
	my($n,$b,$base) = @_;
	eval q( &REST_8VR($n,$b,$base);  &REST_8VR($n+8,$b,$base));
    }
}
unless(defined(&REST_32VR)) {
    sub REST_32VR {
	my($n,$b,$base) = @_;
	eval q( &REST_16VR($n,$b,$base);  &REST_16VR($n+16,$b,$base));
    }
}
if(defined(&CONFIG_PPC601_SYNC_FIX)) {
    eval 'sub SYNC () { &BEGIN_FTR_SECTION  &sync;  &isync;  &END_FTR_SECTION_IFSET( &CPU_FTR_601);}' unless defined(&SYNC);
    eval 'sub SYNC_601 () { &BEGIN_FTR_SECTION  &sync;  &END_FTR_SECTION_IFSET( &CPU_FTR_601);}' unless defined(&SYNC_601);
    eval 'sub ISYNC_601 () { &BEGIN_FTR_SECTION  &isync;  &END_FTR_SECTION_IFSET( &CPU_FTR_601);}' unless defined(&ISYNC_601);
} else {
    eval 'sub SYNC () {1;}' unless defined(&SYNC);
    eval 'sub SYNC_601 () {1;}' unless defined(&SYNC_601);
    eval 'sub ISYNC_601 () {1;}' unless defined(&ISYNC_601);
}
unless(defined(&CONFIG_SMP)) {
    eval 'sub TLBSYNC () {1;}' unless defined(&TLBSYNC);
} else {
    eval 'sub TLBSYNC () { &BEGIN_FTR_SECTION  &tlbsync;  &sync;  &END_FTR_SECTION_IFCLR( &CPU_FTR_601);}' unless defined(&TLBSYNC);
}
if(!defined( &CONFIG_4xx)  && !defined( &CONFIG_8xx)) {
    eval 'sub tlbia () { &li  &r4,1024;  &mtctr  &r4;  &lis  &r4, &KERNELBASE@ &h; 0:  &tlbie  &r4;  &addi  &r4, &r4,0x1000;  &bdnz 0 &b;}' unless defined(&tlbia);
}
if(defined(&CONFIG_BOOKE)) {
    eval 'sub tophys {
        my($rd,$rs) = @_;
	    eval q( &mr $rd,$rs);
    }' unless defined(&tophys);
    eval 'sub tovirt {
        my($rd,$rs) = @_;
	    eval q( &mr $rd,$rs);
    }' unless defined(&tovirt);
} else {
    eval 'sub tophys {
        my($rd,$rs) = @_;
	    eval q(0:  &addis $rd,$rs,- &KERNELBASE@ &h; . &section \\".vtop_fixup\\",\\"aw\\"; . &align 1; .\'long 0b\'; . &previous);
    }' unless defined(&tophys);
    eval 'sub tovirt {
        my($rd,$rs) = @_;
	    eval q(0:  &addis $rd,$rs, &KERNELBASE@ &h; . &section \\".ptov_fixup\\",\\"aw\\"; . &align 1; .\'long 0b\'; . &previous);
    }' unless defined(&tovirt);
}
if(defined(&CONFIG_PPC64BRIDGE)) {
    eval 'sub FIX_SRR1 {
        my($ra, $rb) = @_;
	    eval q( &mr $rb,$ra;  &mfmsr $ra;  &clrldi $ra,$ra,1;  &rldimi $ra,$rb,0,32);
    }' unless defined(&FIX_SRR1);
    eval 'sub RFI () {.\'long 0x4c000024\';}' unless defined(&RFI);
    eval 'sub MTMSRD {
        my($r) = @_;
	    eval q(. &long (0x7c000164 + (($r) << 21)));
    }' unless defined(&MTMSRD);
    eval 'sub CLR_TOP32 {
        my($r) = @_;
	    eval q( &rlwinm ($r),($r),0,0,31);
    }' unless defined(&CLR_TOP32);
} else {
    eval 'sub FIX_SRR1 {
        my($ra, $rb) = @_;
	    eval q();
    }' unless defined(&FIX_SRR1);
    unless(defined(&CONFIG_4xx)) {
	eval 'sub RFI () { &rfi;}' unless defined(&RFI);
    } else {
	eval 'sub RFI () { &rfi;  &b .;}' unless defined(&RFI);
    }
    eval 'sub MTMSRD {
        my($r) = @_;
	    eval q( &mtmsr $r);
    }' unless defined(&MTMSRD);
    eval 'sub CLR_TOP32 {
        my($r) = @_;
	    eval q();
    }' unless defined(&CLR_TOP32);
}
unless(defined(&RFMCI)) {
    sub RFMCI () {	.'long 0x4c00004c';}
}
if(defined(&CONFIG_IBM405_ERR77)) {
    eval 'sub PPC405_ERR77 {
        my($ra,$rb) = @_;
	    eval q( &dcbt $ra, $rb;);
    }' unless defined(&PPC405_ERR77);
    eval 'sub PPC405_ERR77_SYNC () { &sync;;}' unless defined(&PPC405_ERR77_SYNC);
} else {
    eval 'sub PPC405_ERR77 {
        my($ra,$rb) = @_;
	    eval q();
    }' unless defined(&PPC405_ERR77);
    eval 'sub PPC405_ERR77_SYNC () {1;}' unless defined(&PPC405_ERR77_SYNC);
}
unless(defined(&cr0)) {
    sub cr0 () {	0;}
}
unless(defined(&cr1)) {
    sub cr1 () {	1;}
}
unless(defined(&cr2)) {
    sub cr2 () {	2;}
}
unless(defined(&cr3)) {
    sub cr3 () {	3;}
}
unless(defined(&cr4)) {
    sub cr4 () {	4;}
}
unless(defined(&cr5)) {
    sub cr5 () {	5;}
}
unless(defined(&cr6)) {
    sub cr6 () {	6;}
}
unless(defined(&cr7)) {
    sub cr7 () {	7;}
}
unless(defined(&r0)) {
    sub r0 () {	0;}
}
unless(defined(&r1)) {
    sub r1 () {	1;}
}
unless(defined(&r2)) {
    sub r2 () {	2;}
}
unless(defined(&r3)) {
    sub r3 () {	3;}
}
unless(defined(&r4)) {
    sub r4 () {	4;}
}
unless(defined(&r5)) {
    sub r5 () {	5;}
}
unless(defined(&r6)) {
    sub r6 () {	6;}
}
unless(defined(&r7)) {
    sub r7 () {	7;}
}
unless(defined(&r8)) {
    sub r8 () {	8;}
}
unless(defined(&r9)) {
    sub r9 () {	9;}
}
unless(defined(&r10)) {
    sub r10 () {	10;}
}
unless(defined(&r11)) {
    sub r11 () {	11;}
}
unless(defined(&r12)) {
    sub r12 () {	12;}
}
unless(defined(&r13)) {
    sub r13 () {	13;}
}
unless(defined(&r14)) {
    sub r14 () {	14;}
}
unless(defined(&r15)) {
    sub r15 () {	15;}
}
unless(defined(&r16)) {
    sub r16 () {	16;}
}
unless(defined(&r17)) {
    sub r17 () {	17;}
}
unless(defined(&r18)) {
    sub r18 () {	18;}
}
unless(defined(&r19)) {
    sub r19 () {	19;}
}
unless(defined(&r20)) {
    sub r20 () {	20;}
}
unless(defined(&r21)) {
    sub r21 () {	21;}
}
unless(defined(&r22)) {
    sub r22 () {	22;}
}
unless(defined(&r23)) {
    sub r23 () {	23;}
}
unless(defined(&r24)) {
    sub r24 () {	24;}
}
unless(defined(&r25)) {
    sub r25 () {	25;}
}
unless(defined(&r26)) {
    sub r26 () {	26;}
}
unless(defined(&r27)) {
    sub r27 () {	27;}
}
unless(defined(&r28)) {
    sub r28 () {	28;}
}
unless(defined(&r29)) {
    sub r29 () {	29;}
}
unless(defined(&r30)) {
    sub r30 () {	30;}
}
unless(defined(&r31)) {
    sub r31 () {	31;}
}
unless(defined(&fr0)) {
    sub fr0 () {	0;}
}
unless(defined(&fr1)) {
    sub fr1 () {	1;}
}
unless(defined(&fr2)) {
    sub fr2 () {	2;}
}
unless(defined(&fr3)) {
    sub fr3 () {	3;}
}
unless(defined(&fr4)) {
    sub fr4 () {	4;}
}
unless(defined(&fr5)) {
    sub fr5 () {	5;}
}
unless(defined(&fr6)) {
    sub fr6 () {	6;}
}
unless(defined(&fr7)) {
    sub fr7 () {	7;}
}
unless(defined(&fr8)) {
    sub fr8 () {	8;}
}
unless(defined(&fr9)) {
    sub fr9 () {	9;}
}
unless(defined(&fr10)) {
    sub fr10 () {	10;}
}
unless(defined(&fr11)) {
    sub fr11 () {	11;}
}
unless(defined(&fr12)) {
    sub fr12 () {	12;}
}
unless(defined(&fr13)) {
    sub fr13 () {	13;}
}
unless(defined(&fr14)) {
    sub fr14 () {	14;}
}
unless(defined(&fr15)) {
    sub fr15 () {	15;}
}
unless(defined(&fr16)) {
    sub fr16 () {	16;}
}
unless(defined(&fr17)) {
    sub fr17 () {	17;}
}
unless(defined(&fr18)) {
    sub fr18 () {	18;}
}
unless(defined(&fr19)) {
    sub fr19 () {	19;}
}
unless(defined(&fr20)) {
    sub fr20 () {	20;}
}
unless(defined(&fr21)) {
    sub fr21 () {	21;}
}
unless(defined(&fr22)) {
    sub fr22 () {	22;}
}
unless(defined(&fr23)) {
    sub fr23 () {	23;}
}
unless(defined(&fr24)) {
    sub fr24 () {	24;}
}
unless(defined(&fr25)) {
    sub fr25 () {	25;}
}
unless(defined(&fr26)) {
    sub fr26 () {	26;}
}
unless(defined(&fr27)) {
    sub fr27 () {	27;}
}
unless(defined(&fr28)) {
    sub fr28 () {	28;}
}
unless(defined(&fr29)) {
    sub fr29 () {	29;}
}
unless(defined(&fr30)) {
    sub fr30 () {	30;}
}
unless(defined(&fr31)) {
    sub fr31 () {	31;}
}
unless(defined(&vr0)) {
    sub vr0 () {	0;}
}
unless(defined(&vr1)) {
    sub vr1 () {	1;}
}
unless(defined(&vr2)) {
    sub vr2 () {	2;}
}
unless(defined(&vr3)) {
    sub vr3 () {	3;}
}
unless(defined(&vr4)) {
    sub vr4 () {	4;}
}
unless(defined(&vr5)) {
    sub vr5 () {	5;}
}
unless(defined(&vr6)) {
    sub vr6 () {	6;}
}
unless(defined(&vr7)) {
    sub vr7 () {	7;}
}
unless(defined(&vr8)) {
    sub vr8 () {	8;}
}
unless(defined(&vr9)) {
    sub vr9 () {	9;}
}
unless(defined(&vr10)) {
    sub vr10 () {	10;}
}
unless(defined(&vr11)) {
    sub vr11 () {	11;}
}
unless(defined(&vr12)) {
    sub vr12 () {	12;}
}
unless(defined(&vr13)) {
    sub vr13 () {	13;}
}
unless(defined(&vr14)) {
    sub vr14 () {	14;}
}
unless(defined(&vr15)) {
    sub vr15 () {	15;}
}
unless(defined(&vr16)) {
    sub vr16 () {	16;}
}
unless(defined(&vr17)) {
    sub vr17 () {	17;}
}
unless(defined(&vr18)) {
    sub vr18 () {	18;}
}
unless(defined(&vr19)) {
    sub vr19 () {	19;}
}
unless(defined(&vr20)) {
    sub vr20 () {	20;}
}
unless(defined(&vr21)) {
    sub vr21 () {	21;}
}
unless(defined(&vr22)) {
    sub vr22 () {	22;}
}
unless(defined(&vr23)) {
    sub vr23 () {	23;}
}
unless(defined(&vr24)) {
    sub vr24 () {	24;}
}
unless(defined(&vr25)) {
    sub vr25 () {	25;}
}
unless(defined(&vr26)) {
    sub vr26 () {	26;}
}
unless(defined(&vr27)) {
    sub vr27 () {	27;}
}
unless(defined(&vr28)) {
    sub vr28 () {	28;}
}
unless(defined(&vr29)) {
    sub vr29 () {	29;}
}
unless(defined(&vr30)) {
    sub vr30 () {	30;}
}
unless(defined(&vr31)) {
    sub vr31 () {	31;}
}
unless(defined(&N_FUN)) {
    sub N_FUN () {	36;}
}
unless(defined(&N_RSYM)) {
    sub N_RSYM () {	64;}
}
unless(defined(&N_SLINE)) {
    sub N_SLINE () {	68;}
}
unless(defined(&N_SO)) {
    sub N_SO () {	100;}
}
1;
