require '_h2ph_pre.ph';

no warnings 'redefine';

if(defined(&__KERNEL__)) {
    unless(defined(&__ASM_PPC_PROCESSOR_H)) {
	eval 'sub __ASM_PPC_PROCESSOR_H () {1;}' unless defined(&__ASM_PPC_PROCESSOR_H);
	eval 'sub current_text_addr () {
	    eval q(({  &__label__  &_l;  &_l:  && &_l;}));
	}' unless defined(&current_text_addr);
	require 'linux/config.ph';
	require 'linux/stringify.ph';
	require 'asm/ptrace.ph';
	require 'asm/types.ph';
	require 'asm/mpc8xx.ph';
	if(defined(&CONFIG_PPC64BRIDGE)) {
	    eval 'sub MSR_SF () {(1<<63);}' unless defined(&MSR_SF);
	    eval 'sub MSR_ISF () {(1<<61);}' unless defined(&MSR_ISF);
	}
	eval 'sub MSR_VEC () {(1<<25);}' unless defined(&MSR_VEC);
	eval 'sub MSR_POW () {(1<<18);}' unless defined(&MSR_POW);
	eval 'sub MSR_WE () {(1<<18);}' unless defined(&MSR_WE);
	eval 'sub MSR_TGPR () {(1<<17);}' unless defined(&MSR_TGPR);
	eval 'sub MSR_CE () {(1<<17);}' unless defined(&MSR_CE);
	eval 'sub MSR_ILE () {(1<<16);}' unless defined(&MSR_ILE);
	eval 'sub MSR_EE () {(1<<15);}' unless defined(&MSR_EE);
	eval 'sub MSR_PR () {(1<<14);}' unless defined(&MSR_PR);
	eval 'sub MSR_FP () {(1<<13);}' unless defined(&MSR_FP);
	eval 'sub MSR_ME () {(1<<12);}' unless defined(&MSR_ME);
	eval 'sub MSR_FE0 () {(1<<11);}' unless defined(&MSR_FE0);
	eval 'sub MSR_SE () {(1<<10);}' unless defined(&MSR_SE);
	eval 'sub MSR_DWE () {(1<<10);}' unless defined(&MSR_DWE);
	eval 'sub MSR_BE () {(1<<9);}' unless defined(&MSR_BE);
	eval 'sub MSR_DE () {(1<<9);}' unless defined(&MSR_DE);
	eval 'sub MSR_FE1 () {(1<<8);}' unless defined(&MSR_FE1);
	eval 'sub MSR_IP () {(1<<6);}' unless defined(&MSR_IP);
	eval 'sub MSR_IR () {(1<<5);}' unless defined(&MSR_IR);
	eval 'sub MSR_DR () {(1<<4);}' unless defined(&MSR_DR);
	eval 'sub MSR_PE () {(1<<3);}' unless defined(&MSR_PE);
	eval 'sub MSR_PX () {(1<<2);}' unless defined(&MSR_PX);
	eval 'sub MSR_RI () {(1<<1);}' unless defined(&MSR_RI);
	eval 'sub MSR_LE () {(1<<0);}' unless defined(&MSR_LE);
	if(defined(&CONFIG_BOOKE)) {
	    eval 'sub MSR_IS () { &MSR_IR;}' unless defined(&MSR_IS);
	    eval 'sub MSR_DS () { &MSR_DR;}' unless defined(&MSR_DS);
	}
	if(defined(&CONFIG_APUS_FAST_EXCEPT)) {
	    eval 'sub MSR_ () { &MSR_ME| &MSR_IP| &MSR_RI;}' unless defined(&MSR_);
	} else {
	    eval 'sub MSR_ () { &MSR_ME| &MSR_RI;}' unless defined(&MSR_);
	}
	eval 'sub MSR_KERNEL () { &MSR_| &MSR_IR| &MSR_DR;}' unless defined(&MSR_KERNEL);
	eval 'sub MSR_USER () { &MSR_KERNEL| &MSR_PR| &MSR_EE;}' unless defined(&MSR_USER);
	eval 'sub FPSCR_FX () {0x80000000;}' unless defined(&FPSCR_FX);
	eval 'sub FPSCR_FEX () {0x40000000;}' unless defined(&FPSCR_FEX);
	eval 'sub FPSCR_VX () {0x20000000;}' unless defined(&FPSCR_VX);
	eval 'sub FPSCR_OX () {0x10000000;}' unless defined(&FPSCR_OX);
	eval 'sub FPSCR_UX () {0x8000000;}' unless defined(&FPSCR_UX);
	eval 'sub FPSCR_ZX () {0x4000000;}' unless defined(&FPSCR_ZX);
	eval 'sub FPSCR_XX () {0x2000000;}' unless defined(&FPSCR_XX);
	eval 'sub FPSCR_VXSNAN () {0x1000000;}' unless defined(&FPSCR_VXSNAN);
	eval 'sub FPSCR_VXISI () {0x800000;}' unless defined(&FPSCR_VXISI);
	eval 'sub FPSCR_VXIDI () {0x400000;}' unless defined(&FPSCR_VXIDI);
	eval 'sub FPSCR_VXZDZ () {0x200000;}' unless defined(&FPSCR_VXZDZ);
	eval 'sub FPSCR_VXIMZ () {0x100000;}' unless defined(&FPSCR_VXIMZ);
	eval 'sub FPSCR_VXVC () {0x80000;}' unless defined(&FPSCR_VXVC);
	eval 'sub FPSCR_FR () {0x40000;}' unless defined(&FPSCR_FR);
	eval 'sub FPSCR_FI () {0x20000;}' unless defined(&FPSCR_FI);
	eval 'sub FPSCR_FPRF () {0x1f000;}' unless defined(&FPSCR_FPRF);
	eval 'sub FPSCR_FPCC () {0xf000;}' unless defined(&FPSCR_FPCC);
	eval 'sub FPSCR_VXSOFT () {0x400;}' unless defined(&FPSCR_VXSOFT);
	eval 'sub FPSCR_VXSQRT () {0x200;}' unless defined(&FPSCR_VXSQRT);
	eval 'sub FPSCR_VXCVI () {0x100;}' unless defined(&FPSCR_VXCVI);
	eval 'sub FPSCR_VE () {0x80;}' unless defined(&FPSCR_VE);
	eval 'sub FPSCR_OE () {0x40;}' unless defined(&FPSCR_OE);
	eval 'sub FPSCR_UE () {0x20;}' unless defined(&FPSCR_UE);
	eval 'sub FPSCR_ZE () {0x10;}' unless defined(&FPSCR_ZE);
	eval 'sub FPSCR_XE () {0x8;}' unless defined(&FPSCR_XE);
	eval 'sub FPSCR_NI () {0x4;}' unless defined(&FPSCR_NI);
	eval 'sub FPSCR_RN () {0x3;}' unless defined(&FPSCR_RN);
	eval 'sub SPRN_CCR0 () {0x3b3;}' unless defined(&SPRN_CCR0);
	eval 'sub SPRN_CDBCR () {0x3d7;}' unless defined(&SPRN_CDBCR);
	eval 'sub SPRN_CTR () {0x9;}' unless defined(&SPRN_CTR);
	eval 'sub SPRN_DABR () {0x3f5;}' unless defined(&SPRN_DABR);
	if(defined(&CONFIG_BOOKE)) {
	    eval 'sub SPRN_DAC1 () {0x13c;}' unless defined(&SPRN_DAC1);
	    eval 'sub SPRN_DAC2 () {0x13d;}' unless defined(&SPRN_DAC2);
	} else {
	    eval 'sub SPRN_DAC1 () {0x3f6;}' unless defined(&SPRN_DAC1);
	    eval 'sub SPRN_DAC2 () {0x3f7;}' unless defined(&SPRN_DAC2);
	}
	eval 'sub SPRN_DAR () {0x13;}' unless defined(&SPRN_DAR);
	eval 'sub SPRN_DBAT0L () {0x219;}' unless defined(&SPRN_DBAT0L);
	eval 'sub SPRN_DBAT0U () {0x218;}' unless defined(&SPRN_DBAT0U);
	eval 'sub SPRN_DBAT1L () {0x21b;}' unless defined(&SPRN_DBAT1L);
	eval 'sub SPRN_DBAT1U () {0x21a;}' unless defined(&SPRN_DBAT1U);
	eval 'sub SPRN_DBAT2L () {0x21d;}' unless defined(&SPRN_DBAT2L);
	eval 'sub SPRN_DBAT2U () {0x21c;}' unless defined(&SPRN_DBAT2U);
	eval 'sub SPRN_DBAT3L () {0x21f;}' unless defined(&SPRN_DBAT3L);
	eval 'sub SPRN_DBAT3U () {0x21e;}' unless defined(&SPRN_DBAT3U);
	eval 'sub SPRN_DBAT4L () {0x239;}' unless defined(&SPRN_DBAT4L);
	eval 'sub SPRN_DBAT4U () {0x238;}' unless defined(&SPRN_DBAT4U);
	eval 'sub SPRN_DBAT5L () {0x23b;}' unless defined(&SPRN_DBAT5L);
	eval 'sub SPRN_DBAT5U () {0x23a;}' unless defined(&SPRN_DBAT5U);
	eval 'sub SPRN_DBAT6L () {0x23d;}' unless defined(&SPRN_DBAT6L);
	eval 'sub SPRN_DBAT6U () {0x23c;}' unless defined(&SPRN_DBAT6U);
	eval 'sub SPRN_DBAT7L () {0x23f;}' unless defined(&SPRN_DBAT7L);
	eval 'sub SPRN_DBAT7U () {0x23e;}' unless defined(&SPRN_DBAT7U);
	eval 'sub SPRN_DBCR () {0x3f2;}' unless defined(&SPRN_DBCR);
	eval 'sub DBCR_EDM () {0x80000000;}' unless defined(&DBCR_EDM);
	eval 'sub DBCR_IDM () {0x40000000;}' unless defined(&DBCR_IDM);
	eval 'sub DBCR_RST {
	    my($x) = @_;
    	    eval q(((($x) & 0x3) << 28));
	}' unless defined(&DBCR_RST);
	eval 'sub DBCR_RST_NONE () {0;}' unless defined(&DBCR_RST_NONE);
	eval 'sub DBCR_RST_CORE () {1;}' unless defined(&DBCR_RST_CORE);
	eval 'sub DBCR_RST_CHIP () {2;}' unless defined(&DBCR_RST_CHIP);
	eval 'sub DBCR_RST_SYSTEM () {3;}' unless defined(&DBCR_RST_SYSTEM);
	eval 'sub DBCR_IC () {0x8000000;}' unless defined(&DBCR_IC);
	eval 'sub DBCR_BT () {0x4000000;}' unless defined(&DBCR_BT);
	eval 'sub DBCR_EDE () {0x2000000;}' unless defined(&DBCR_EDE);
	eval 'sub DBCR_TDE () {0x1000000;}' unless defined(&DBCR_TDE);
	eval 'sub DBCR_FER () {0xf80000;}' unless defined(&DBCR_FER);
	eval 'sub DBCR_FT () {0x40000;}' unless defined(&DBCR_FT);
	eval 'sub DBCR_IA1 () {0x20000;}' unless defined(&DBCR_IA1);
	eval 'sub DBCR_IA2 () {0x10000;}' unless defined(&DBCR_IA2);
	eval 'sub DBCR_D1R () {0x8000;}' unless defined(&DBCR_D1R);
	eval 'sub DBCR_D1W () {0x4000;}' unless defined(&DBCR_D1W);
	eval 'sub DBCR_D1S {
	    my($x) = @_;
    	    eval q(((($x) & 0x3) << 12));
	}' unless defined(&DBCR_D1S);
	eval 'sub DAC_BYTE () {0;}' unless defined(&DAC_BYTE);
	eval 'sub DAC_HALF () {1;}' unless defined(&DAC_HALF);
	eval 'sub DAC_WORD () {2;}' unless defined(&DAC_WORD);
	eval 'sub DAC_QUAD () {3;}' unless defined(&DAC_QUAD);
	eval 'sub DBCR_D2R () {0x800;}' unless defined(&DBCR_D2R);
	eval 'sub DBCR_D2W () {0x400;}' unless defined(&DBCR_D2W);
	eval 'sub DBCR_D2S {
	    my($x) = @_;
    	    eval q(((($x) & 0x3) << 8));
	}' unless defined(&DBCR_D2S);
	eval 'sub DBCR_SBT () {0x40;}' unless defined(&DBCR_SBT);
	eval 'sub DBCR_SED () {0x20;}' unless defined(&DBCR_SED);
	eval 'sub DBCR_STD () {0x10;}' unless defined(&DBCR_STD);
	eval 'sub DBCR_SIA () {0x8;}' unless defined(&DBCR_SIA);
	eval 'sub DBCR_SDA () {0x4;}' unless defined(&DBCR_SDA);
	eval 'sub DBCR_JOI () {0x2;}' unless defined(&DBCR_JOI);
	eval 'sub DBCR_JII () {0x1;}' unless defined(&DBCR_JII);
	if(defined(&CONFIG_BOOKE)) {
	    eval 'sub SPRN_DBCR0 () {0x134;}' unless defined(&SPRN_DBCR0);
	} else {
	    eval 'sub SPRN_DBCR0 () {0x3f2;}' unless defined(&SPRN_DBCR0);
	}
	eval 'sub DBCR0_EDM () {0x80000000;}' unless defined(&DBCR0_EDM);
	eval 'sub DBCR0_IDM () {0x40000000;}' unless defined(&DBCR0_IDM);
	eval 'sub DBCR0_RST () {0x30000000;}' unless defined(&DBCR0_RST);
	eval 'sub DBCR0_RST_SYSTEM () {0x30000000;}' unless defined(&DBCR0_RST_SYSTEM);
	eval 'sub DBCR0_RST_CHIP () {0x20000000;}' unless defined(&DBCR0_RST_CHIP);
	eval 'sub DBCR0_RST_CORE () {0x10000000;}' unless defined(&DBCR0_RST_CORE);
	eval 'sub DBCR0_RST_NONE () {0x;}' unless defined(&DBCR0_RST_NONE);
	eval 'sub DBCR0_IC () {0x8000000;}' unless defined(&DBCR0_IC);
	eval 'sub DBCR0_BT () {0x4000000;}' unless defined(&DBCR0_BT);
	eval 'sub DBCR0_EDE () {0x2000000;}' unless defined(&DBCR0_EDE);
	eval 'sub DBCR0_TDE () {0x1000000;}' unless defined(&DBCR0_TDE);
	eval 'sub DBCR0_IA1 () {0x800000;}' unless defined(&DBCR0_IA1);
	eval 'sub DBCR0_IA2 () {0x400000;}' unless defined(&DBCR0_IA2);
	eval 'sub DBCR0_IA12 () {0x200000;}' unless defined(&DBCR0_IA12);
	eval 'sub DBCR0_IA12X () {0x100000;}' unless defined(&DBCR0_IA12X);
	eval 'sub DBCR0_IA3 () {0x80000;}' unless defined(&DBCR0_IA3);
	eval 'sub DBCR0_IA4 () {0x40000;}' unless defined(&DBCR0_IA4);
	eval 'sub DBCR0_IA34 () {0x20000;}' unless defined(&DBCR0_IA34);
	eval 'sub DBCR0_IA34X () {0x10000;}' unless defined(&DBCR0_IA34X);
	eval 'sub DBCR0_IA12T () {0x8000;}' unless defined(&DBCR0_IA12T);
	eval 'sub DBCR0_IA34T () {0x4000;}' unless defined(&DBCR0_IA34T);
	eval 'sub DBCR0_FT () {0x1;}' unless defined(&DBCR0_FT);
	if(defined(&CONFIG_BOOKE)) {
	    eval 'sub SPRN_DBCR1 () {0x135;}' unless defined(&SPRN_DBCR1);
	    eval 'sub SPRN_DBSR () {0x130;}' unless defined(&SPRN_DBSR);
	    eval 'sub DBSR_IC () {0x8000000;}' unless defined(&DBSR_IC);
	    eval 'sub DBSR_TIE () {0x1000000;}' unless defined(&DBSR_TIE);
	} else {
	    eval 'sub SPRN_DBCR1 () {0x3bd;}' unless defined(&SPRN_DBCR1);
	    eval 'sub SPRN_DBSR () {0x3f0;}' unless defined(&SPRN_DBSR);
	    eval 'sub DBSR_IC () {0x80000000;}' unless defined(&DBSR_IC);
	    eval 'sub DBSR_TIE () {0x10000000;}' unless defined(&DBSR_TIE);
	}
	eval 'sub SPRN_DCCR () {0x3fa;}' unless defined(&SPRN_DCCR);
	eval 'sub DCCR_NOCACHE () {0;}' unless defined(&DCCR_NOCACHE);
	eval 'sub DCCR_CACHE () {1;}' unless defined(&DCCR_CACHE);
	eval 'sub SPRN_DCMP () {0x3d1;}' unless defined(&SPRN_DCMP);
	eval 'sub SPRN_DCWR () {0x3ba;}' unless defined(&SPRN_DCWR);
	eval 'sub DCWR_COPY () {0;}' unless defined(&DCWR_COPY);
	eval 'sub DCWR_WRITE () {1;}' unless defined(&DCWR_WRITE);
	if(defined(&CONFIG_BOOKE)) {
	    eval 'sub SPRN_DEAR () {0x3d;}' unless defined(&SPRN_DEAR);
	} else {
	    eval 'sub SPRN_DEAR () {0x3d5;}' unless defined(&SPRN_DEAR);
	}
	eval 'sub SPRN_DEC () {0x16;}' unless defined(&SPRN_DEC);
	eval 'sub SPRN_DER () {0x95;}' unless defined(&SPRN_DER);
	eval 'sub DER_RSTE () {0x40000000;}' unless defined(&DER_RSTE);
	eval 'sub DER_CHSTPE () {0x20000000;}' unless defined(&DER_CHSTPE);
	eval 'sub DER_MCIE () {0x10000000;}' unless defined(&DER_MCIE);
	eval 'sub DER_EXTIE () {0x2000000;}' unless defined(&DER_EXTIE);
	eval 'sub DER_ALIE () {0x1000000;}' unless defined(&DER_ALIE);
	eval 'sub DER_PRIE () {0x800000;}' unless defined(&DER_PRIE);
	eval 'sub DER_FPUVIE () {0x400000;}' unless defined(&DER_FPUVIE);
	eval 'sub DER_DECIE () {0x200000;}' unless defined(&DER_DECIE);
	eval 'sub DER_SYSIE () {0x40000;}' unless defined(&DER_SYSIE);
	eval 'sub DER_TRE () {0x20000;}' unless defined(&DER_TRE);
	eval 'sub DER_SEIE () {0x4000;}' unless defined(&DER_SEIE);
	eval 'sub DER_ITLBMSE () {0x2000;}' unless defined(&DER_ITLBMSE);
	eval 'sub DER_ITLBERE () {0x1000;}' unless defined(&DER_ITLBERE);
	eval 'sub DER_DTLBMSE () {0x800;}' unless defined(&DER_DTLBMSE);
	eval 'sub DER_DTLBERE () {0x400;}' unless defined(&DER_DTLBERE);
	eval 'sub DER_LBRKE () {0x8;}' unless defined(&DER_LBRKE);
	eval 'sub DER_IBRKE () {0x4;}' unless defined(&DER_IBRKE);
	eval 'sub DER_EBRKE () {0x2;}' unless defined(&DER_EBRKE);
	eval 'sub DER_DPIE () {0x1;}' unless defined(&DER_DPIE);
	eval 'sub SPRN_DMISS () {0x3d0;}' unless defined(&SPRN_DMISS);
	eval 'sub SPRN_DSISR () {0x12;}' unless defined(&SPRN_DSISR);
	eval 'sub SPRN_EAR () {0x11a;}' unless defined(&SPRN_EAR);
	if(defined(&CONFIG_BOOKE)) {
	    eval 'sub SPRN_ESR () {0x3e;}' unless defined(&SPRN_ESR);
	} else {
	    eval 'sub SPRN_ESR () {0x3d4;}' unless defined(&SPRN_ESR);
	}
	eval 'sub ESR_IMCP () {0x80000000;}' unless defined(&ESR_IMCP);
	eval 'sub ESR_IMCN () {0x40000000;}' unless defined(&ESR_IMCN);
	eval 'sub ESR_IMCB () {0x20000000;}' unless defined(&ESR_IMCB);
	eval 'sub ESR_IMCT () {0x10000000;}' unless defined(&ESR_IMCT);
	eval 'sub ESR_PIL () {0x8000000;}' unless defined(&ESR_PIL);
	eval 'sub ESR_PPR () {0x4000000;}' unless defined(&ESR_PPR);
	eval 'sub ESR_PTR () {0x2000000;}' unless defined(&ESR_PTR);
	eval 'sub ESR_DST () {0x800000;}' unless defined(&ESR_DST);
	eval 'sub ESR_DIZ () {0x400000;}' unless defined(&ESR_DIZ);
	eval 'sub SPRN_EVPR () {0x3d6;}' unless defined(&SPRN_EVPR);
	eval 'sub SPRN_HASH1 () {0x3d2;}' unless defined(&SPRN_HASH1);
	eval 'sub SPRN_HASH2 () {0x3d3;}' unless defined(&SPRN_HASH2);
	eval 'sub SPRN_HID0 () {0x3f0;}' unless defined(&SPRN_HID0);
	eval 'sub HID0_EMCP () {(1<<31);}' unless defined(&HID0_EMCP);
	eval 'sub HID0_EBA () {(1<<29);}' unless defined(&HID0_EBA);
	eval 'sub HID0_EBD () {(1<<28);}' unless defined(&HID0_EBD);
	eval 'sub HID0_SBCLK () {(1<<27);}' unless defined(&HID0_SBCLK);
	eval 'sub HID0_EICE () {(1<<26);}' unless defined(&HID0_EICE);
	eval 'sub HID0_TBEN () {(1<<26);}' unless defined(&HID0_TBEN);
	eval 'sub HID0_ECLK () {(1<<25);}' unless defined(&HID0_ECLK);
	eval 'sub HID0_PAR () {(1<<24);}' unless defined(&HID0_PAR);
	eval 'sub HID0_STEN () {(1<<24);}' unless defined(&HID0_STEN);
	eval 'sub HID0_HIGH_BAT () {(1<<23);}' unless defined(&HID0_HIGH_BAT);
	eval 'sub HID0_DOZE () {(1<<23);}' unless defined(&HID0_DOZE);
	eval 'sub HID0_NAP () {(1<<22);}' unless defined(&HID0_NAP);
	eval 'sub HID0_SLEEP () {(1<<21);}' unless defined(&HID0_SLEEP);
	eval 'sub HID0_DPM () {(1<<20);}' unless defined(&HID0_DPM);
	eval 'sub HID0_BHTCLR () {(1<<18);}' unless defined(&HID0_BHTCLR);
	eval 'sub HID0_XAEN () {(1<<17);}' unless defined(&HID0_XAEN);
	eval 'sub HID0_NHR () {(1<<16);}' unless defined(&HID0_NHR);
	eval 'sub HID0_ICE () {(1<<15);}' unless defined(&HID0_ICE);
	eval 'sub HID0_DCE () {(1<<14);}' unless defined(&HID0_DCE);
	eval 'sub HID0_ILOCK () {(1<<13);}' unless defined(&HID0_ILOCK);
	eval 'sub HID0_DLOCK () {(1<<12);}' unless defined(&HID0_DLOCK);
	eval 'sub HID0_ICFI () {(1<<11);}' unless defined(&HID0_ICFI);
	eval 'sub HID0_DCI () {(1<<10);}' unless defined(&HID0_DCI);
	eval 'sub HID0_SPD () {(1<<9);}' unless defined(&HID0_SPD);
	eval 'sub HID0_SGE () {(1<<7);}' unless defined(&HID0_SGE);
	eval 'sub HID0_SIED () {(1<<7);}' unless defined(&HID0_SIED);
	eval 'sub HID0_DFCA () {(1<<6);}' unless defined(&HID0_DFCA);
	eval 'sub HID0_BTIC () {(1<<5);}' unless defined(&HID0_BTIC);
	eval 'sub HID0_LRSTK () {(1<<4);}' unless defined(&HID0_LRSTK);
	eval 'sub HID0_ABE () {(1<<3);}' unless defined(&HID0_ABE);
	eval 'sub HID0_FOLD () {(1<<3);}' unless defined(&HID0_FOLD);
	eval 'sub HID0_BHTE () {(1<<2);}' unless defined(&HID0_BHTE);
	eval 'sub HID0_BTCD () {(1<<1);}' unless defined(&HID0_BTCD);
	eval 'sub HID0_NOPDST () {(1<<1);}' unless defined(&HID0_NOPDST);
	eval 'sub HID0_NOPTI () {(1<<0);}' unless defined(&HID0_NOPTI);
	eval 'sub SPRN_HID1 () {0x3f1;}' unless defined(&SPRN_HID1);
	eval 'sub HID1_EMCP () {(1<<31);}' unless defined(&HID1_EMCP);
	eval 'sub HID1_PC0 () {(1<<16);}' unless defined(&HID1_PC0);
	eval 'sub HID1_PC1 () {(1<<15);}' unless defined(&HID1_PC1);
	eval 'sub HID1_PC2 () {(1<<14);}' unless defined(&HID1_PC2);
	eval 'sub HID1_PC3 () {(1<<13);}' unless defined(&HID1_PC3);
	eval 'sub HID1_SYNCBE () {(1<<11);}' unless defined(&HID1_SYNCBE);
	eval 'sub HID1_ABE () {(1<<10);}' unless defined(&HID1_ABE);
	eval 'sub SPRN_HID2 () {0x3f8;}' unless defined(&SPRN_HID2);
	eval 'sub SPRN_IABR () {0x3f2;}' unless defined(&SPRN_IABR);
	if(defined(&CONFIG_BOOKE)) {
	    eval 'sub SPRN_IAC1 () {0x138;}' unless defined(&SPRN_IAC1);
	    eval 'sub SPRN_IAC2 () {0x139;}' unless defined(&SPRN_IAC2);
	} else {
	    eval 'sub SPRN_IAC1 () {0x3f4;}' unless defined(&SPRN_IAC1);
	    eval 'sub SPRN_IAC2 () {0x3f5;}' unless defined(&SPRN_IAC2);
	}
	eval 'sub SPRN_IBAT0L () {0x211;}' unless defined(&SPRN_IBAT0L);
	eval 'sub SPRN_IBAT0U () {0x210;}' unless defined(&SPRN_IBAT0U);
	eval 'sub SPRN_IBAT1L () {0x213;}' unless defined(&SPRN_IBAT1L);
	eval 'sub SPRN_IBAT1U () {0x212;}' unless defined(&SPRN_IBAT1U);
	eval 'sub SPRN_IBAT2L () {0x215;}' unless defined(&SPRN_IBAT2L);
	eval 'sub SPRN_IBAT2U () {0x214;}' unless defined(&SPRN_IBAT2U);
	eval 'sub SPRN_IBAT3L () {0x217;}' unless defined(&SPRN_IBAT3L);
	eval 'sub SPRN_IBAT3U () {0x216;}' unless defined(&SPRN_IBAT3U);
	eval 'sub SPRN_IBAT4L () {0x231;}' unless defined(&SPRN_IBAT4L);
	eval 'sub SPRN_IBAT4U () {0x230;}' unless defined(&SPRN_IBAT4U);
	eval 'sub SPRN_IBAT5L () {0x233;}' unless defined(&SPRN_IBAT5L);
	eval 'sub SPRN_IBAT5U () {0x232;}' unless defined(&SPRN_IBAT5U);
	eval 'sub SPRN_IBAT6L () {0x235;}' unless defined(&SPRN_IBAT6L);
	eval 'sub SPRN_IBAT6U () {0x234;}' unless defined(&SPRN_IBAT6U);
	eval 'sub SPRN_IBAT7L () {0x237;}' unless defined(&SPRN_IBAT7L);
	eval 'sub SPRN_IBAT7U () {0x236;}' unless defined(&SPRN_IBAT7U);
	eval 'sub SPRN_ICCR () {0x3fb;}' unless defined(&SPRN_ICCR);
	eval 'sub ICCR_NOCACHE () {0;}' unless defined(&ICCR_NOCACHE);
	eval 'sub ICCR_CACHE () {1;}' unless defined(&ICCR_CACHE);
	eval 'sub SPRN_ICDBDR () {0x3d3;}' unless defined(&SPRN_ICDBDR);
	eval 'sub SPRN_ICMP () {0x3d5;}' unless defined(&SPRN_ICMP);
	eval 'sub SPRN_ICTC () {0x3fb;}' unless defined(&SPRN_ICTC);
	eval 'sub SPRN_ICTRL () {0x3f3;}' unless defined(&SPRN_ICTRL);
	eval 'sub ICTRL_EICE () {0x8000000;}' unless defined(&ICTRL_EICE);
	eval 'sub ICTRL_EDCE () {0x4000000;}' unless defined(&ICTRL_EDCE);
	eval 'sub ICTRL_EICP () {0x100;}' unless defined(&ICTRL_EICP);
	eval 'sub SPRN_IMISS () {0x3d4;}' unless defined(&SPRN_IMISS);
	eval 'sub SPRN_IMMR () {0x27e;}' unless defined(&SPRN_IMMR);
	eval 'sub SPRN_L2CR () {0x3f9;}' unless defined(&SPRN_L2CR);
	eval 'sub L2CR_L2E () {0x80000000;}' unless defined(&L2CR_L2E);
	eval 'sub L2CR_L2PE () {0x40000000;}' unless defined(&L2CR_L2PE);
	eval 'sub L2CR_L2SIZ_MASK () {0x30000000;}' unless defined(&L2CR_L2SIZ_MASK);
	eval 'sub L2CR_L2SIZ_256KB () {0x10000000;}' unless defined(&L2CR_L2SIZ_256KB);
	eval 'sub L2CR_L2SIZ_512KB () {0x20000000;}' unless defined(&L2CR_L2SIZ_512KB);
	eval 'sub L2CR_L2SIZ_1MB () {0x30000000;}' unless defined(&L2CR_L2SIZ_1MB);
	eval 'sub L2CR_L2CLK_MASK () {0xe000000;}' unless defined(&L2CR_L2CLK_MASK);
	eval 'sub L2CR_L2CLK_DISABLED () {0x;}' unless defined(&L2CR_L2CLK_DISABLED);
	eval 'sub L2CR_L2CLK_DIV1 () {0x2000000;}' unless defined(&L2CR_L2CLK_DIV1);
	eval 'sub L2CR_L2CLK_DIV1_5 () {0x4000000;}' unless defined(&L2CR_L2CLK_DIV1_5);
	eval 'sub L2CR_L2CLK_DIV2 () {0x8000000;}' unless defined(&L2CR_L2CLK_DIV2);
	eval 'sub L2CR_L2CLK_DIV2_5 () {0xa000000;}' unless defined(&L2CR_L2CLK_DIV2_5);
	eval 'sub L2CR_L2CLK_DIV3 () {0xc000000;}' unless defined(&L2CR_L2CLK_DIV3);
	eval 'sub L2CR_L2RAM_MASK () {0x1800000;}' unless defined(&L2CR_L2RAM_MASK);
	eval 'sub L2CR_L2RAM_FLOW () {0x;}' unless defined(&L2CR_L2RAM_FLOW);
	eval 'sub L2CR_L2RAM_PIPE () {0x1000000;}' unless defined(&L2CR_L2RAM_PIPE);
	eval 'sub L2CR_L2RAM_PIPE_LW () {0x1800000;}' unless defined(&L2CR_L2RAM_PIPE_LW);
	eval 'sub L2CR_L2DO () {0x400000;}' unless defined(&L2CR_L2DO);
	eval 'sub L2CR_L2I () {0x200000;}' unless defined(&L2CR_L2I);
	eval 'sub L2CR_L2CTL () {0x100000;}' unless defined(&L2CR_L2CTL);
	eval 'sub L2CR_L2WT () {0x80000;}' unless defined(&L2CR_L2WT);
	eval 'sub L2CR_L2TS () {0x40000;}' unless defined(&L2CR_L2TS);
	eval 'sub L2CR_L2OH_MASK () {0x30000;}' unless defined(&L2CR_L2OH_MASK);
	eval 'sub L2CR_L2OH_0_5 () {0x;}' unless defined(&L2CR_L2OH_0_5);
	eval 'sub L2CR_L2OH_1_0 () {0x10000;}' unless defined(&L2CR_L2OH_1_0);
	eval 'sub L2CR_L2SL () {0x8000;}' unless defined(&L2CR_L2SL);
	eval 'sub L2CR_L2DF () {0x4000;}' unless defined(&L2CR_L2DF);
	eval 'sub L2CR_L2BYP () {0x2000;}' unless defined(&L2CR_L2BYP);
	eval 'sub L2CR_L2IP () {0x1;}' unless defined(&L2CR_L2IP);
	eval 'sub SPRN_L2CR2 () {0x3f8;}' unless defined(&SPRN_L2CR2);
	eval 'sub SPRN_L3CR () {0x3fa;}' unless defined(&SPRN_L3CR);
	eval 'sub L3CR_L3E () {0x80000000;}' unless defined(&L3CR_L3E);
	eval 'sub L3CR_L3PE () {0x40000000;}' unless defined(&L3CR_L3PE);
	eval 'sub L3CR_L3APE () {0x20000000;}' unless defined(&L3CR_L3APE);
	eval 'sub L3CR_L3SIZ () {0x10000000;}' unless defined(&L3CR_L3SIZ);
	eval 'sub L3CR_L3CLKEN () {0x8000000;}' unless defined(&L3CR_L3CLKEN);
	eval 'sub L3CR_L3RES () {0x4000000;}' unless defined(&L3CR_L3RES);
	eval 'sub L3CR_L3CLKDIV () {0x3800000;}' unless defined(&L3CR_L3CLKDIV);
	eval 'sub L3CR_L3IO () {0x400000;}' unless defined(&L3CR_L3IO);
	eval 'sub L3CR_L3SPO () {0x40000;}' unless defined(&L3CR_L3SPO);
	eval 'sub L3CR_L3CKSP () {0x30000;}' unless defined(&L3CR_L3CKSP);
	eval 'sub L3CR_L3PSP () {0xe000;}' unless defined(&L3CR_L3PSP);
	eval 'sub L3CR_L3REP () {0x1000;}' unless defined(&L3CR_L3REP);
	eval 'sub L3CR_L3HWF () {0x800;}' unless defined(&L3CR_L3HWF);
	eval 'sub L3CR_L3I () {0x400;}' unless defined(&L3CR_L3I);
	eval 'sub L3CR_L3RT () {0x300;}' unless defined(&L3CR_L3RT);
	eval 'sub L3CR_L3NIRCA () {0x80;}' unless defined(&L3CR_L3NIRCA);
	eval 'sub L3CR_L3DO () {0x40;}' unless defined(&L3CR_L3DO);
	eval 'sub L3CR_PMEN () {0x4;}' unless defined(&L3CR_PMEN);
	eval 'sub L3CR_PMSIZ () {0x1;}' unless defined(&L3CR_PMSIZ);
	eval 'sub SPRN_MSSCR0 () {0x3f6;}' unless defined(&SPRN_MSSCR0);
	eval 'sub SPRN_MSSSR0 () {0x3f7;}' unless defined(&SPRN_MSSSR0);
	eval 'sub SPRN_LDSTCR () {0x3f8;}' unless defined(&SPRN_LDSTCR);
	eval 'sub SPRN_LDSTDB () {0x3f4;}' unless defined(&SPRN_LDSTDB);
	eval 'sub SPRN_LR () {0x8;}' unless defined(&SPRN_LR);
	eval 'sub SPRN_MMCR0 () {0x3b8;}' unless defined(&SPRN_MMCR0);
	eval 'sub SPRN_MMCR1 () {0x3bc;}' unless defined(&SPRN_MMCR1);
	eval 'sub SPRN_PBL1 () {0x3fc;}' unless defined(&SPRN_PBL1);
	eval 'sub SPRN_PBL2 () {0x3fe;}' unless defined(&SPRN_PBL2);
	eval 'sub SPRN_PBU1 () {0x3fd;}' unless defined(&SPRN_PBU1);
	eval 'sub SPRN_PBU2 () {0x3ff;}' unless defined(&SPRN_PBU2);
	if(defined(&CONFIG_BOOKE)) {
	    eval 'sub SPRN_PID () {0x30;}' unless defined(&SPRN_PID);
	    eval 'sub SPRN_PIR () {0x11e;}' unless defined(&SPRN_PIR);
	} else {
	    eval 'sub SPRN_PID () {0x3b1;}' unless defined(&SPRN_PID);
	    eval 'sub SPRN_PIR () {0x3ff;}' unless defined(&SPRN_PIR);
	}
	eval 'sub SPRN_PIT () {0x3db;}' unless defined(&SPRN_PIT);
	eval 'sub SPRN_PMC1 () {0x3b9;}' unless defined(&SPRN_PMC1);
	eval 'sub SPRN_PMC2 () {0x3ba;}' unless defined(&SPRN_PMC2);
	eval 'sub SPRN_PMC3 () {0x3bd;}' unless defined(&SPRN_PMC3);
	eval 'sub SPRN_PMC4 () {0x3be;}' unless defined(&SPRN_PMC4);
	eval 'sub SPRN_PTEHI () {0x3d5;}' unless defined(&SPRN_PTEHI);
	eval 'sub SPRN_PTELO () {0x3d6;}' unless defined(&SPRN_PTELO);
	eval 'sub SPRN_PVR () {0x11f;}' unless defined(&SPRN_PVR);
	eval 'sub SPRN_RPA () {0x3d6;}' unless defined(&SPRN_RPA);
	eval 'sub SPRN_SDA () {0x3bf;}' unless defined(&SPRN_SDA);
	eval 'sub SPRN_SDR1 () {0x19;}' unless defined(&SPRN_SDR1);
	eval 'sub SPRN_SGR () {0x3b9;}' unless defined(&SPRN_SGR);
	eval 'sub SGR_NORMAL () {0;}' unless defined(&SGR_NORMAL);
	eval 'sub SGR_GUARDED () {1;}' unless defined(&SGR_GUARDED);
	eval 'sub SPRN_SIA () {0x3bb;}' unless defined(&SPRN_SIA);
	eval 'sub SPRN_SLER () {0x3bb;}' unless defined(&SPRN_SLER);
	eval 'sub SPRN_SPRG0 () {0x110;}' unless defined(&SPRN_SPRG0);
	eval 'sub SPRN_SPRG1 () {0x111;}' unless defined(&SPRN_SPRG1);
	eval 'sub SPRN_SPRG2 () {0x112;}' unless defined(&SPRN_SPRG2);
	eval 'sub SPRN_SPRG3 () {0x113;}' unless defined(&SPRN_SPRG3);
	eval 'sub SPRN_SPRG4 () {0x114;}' unless defined(&SPRN_SPRG4);
	eval 'sub SPRN_SPRG5 () {0x115;}' unless defined(&SPRN_SPRG5);
	eval 'sub SPRN_SPRG6 () {0x116;}' unless defined(&SPRN_SPRG6);
	eval 'sub SPRN_SPRG7 () {0x117;}' unless defined(&SPRN_SPRG7);
	eval 'sub SPRG4R () { &SPRN_SPRG4R;}' unless defined(&SPRG4R);
	eval 'sub SPRG5R () { &SPRN_SPRG5R;}' unless defined(&SPRG5R);
	eval 'sub SPRG6R () { &SPRN_SPRG6R;}' unless defined(&SPRG6R);
	eval 'sub SPRG7R () { &SPRN_SPRG7R;}' unless defined(&SPRG7R);
	eval 'sub SPRG4W () { &SPRN_SPRG4W;}' unless defined(&SPRG4W);
	eval 'sub SPRG5W () { &SPRN_SPRG5W;}' unless defined(&SPRG5W);
	eval 'sub SPRG6W () { &SPRN_SPRG6W;}' unless defined(&SPRG6W);
	eval 'sub SPRG7W () { &SPRN_SPRG7W;}' unless defined(&SPRG7W);
	eval 'sub SPRN_SRR0 () {0x1a;}' unless defined(&SPRN_SRR0);
	eval 'sub SPRN_SRR1 () {0x1b;}' unless defined(&SPRN_SRR1);
	eval 'sub SPRN_SRR2 () {0x3de;}' unless defined(&SPRN_SRR2);
	eval 'sub SPRN_SRR3 () {0x3df;}' unless defined(&SPRN_SRR3);
	eval 'sub SPRN_SU0R () {0x3bc;}' unless defined(&SPRN_SU0R);
	eval 'sub SPRN_TBHI () {0x3dc;}' unless defined(&SPRN_TBHI);
	eval 'sub SPRN_TBHU () {0x3cc;}' unless defined(&SPRN_TBHU);
	eval 'sub SPRN_TBLO () {0x3dd;}' unless defined(&SPRN_TBLO);
	eval 'sub SPRN_TBLU () {0x3cd;}' unless defined(&SPRN_TBLU);
	eval 'sub SPRN_TBRL () {0x10c;}' unless defined(&SPRN_TBRL);
	eval 'sub SPRN_TBRU () {0x10d;}' unless defined(&SPRN_TBRU);
	eval 'sub SPRN_TBWL () {0x11c;}' unless defined(&SPRN_TBWL);
	eval 'sub SPRN_TBWU () {0x11d;}' unless defined(&SPRN_TBWU);
	if(defined(&CONFIG_BOOKE)) {
	    eval 'sub SPRN_TCR () {0x154;}' unless defined(&SPRN_TCR);
	} else {
	    eval 'sub SPRN_TCR () {0x3da;}' unless defined(&SPRN_TCR);
	}
	eval 'sub TCR_WP {
	    my($x) = @_;
    	    eval q(((($x)&0x3)<<30));
	}' unless defined(&TCR_WP);
	eval 'sub WP_2_17 () {0;}' unless defined(&WP_2_17);
	eval 'sub WP_2_21 () {1;}' unless defined(&WP_2_21);
	eval 'sub WP_2_25 () {2;}' unless defined(&WP_2_25);
	eval 'sub WP_2_29 () {3;}' unless defined(&WP_2_29);
	eval 'sub TCR_WRC {
	    my($x) = @_;
    	    eval q(((($x)&0x3)<<28));
	}' unless defined(&TCR_WRC);
	eval 'sub WRC_NONE () {0;}' unless defined(&WRC_NONE);
	eval 'sub WRC_CORE () {1;}' unless defined(&WRC_CORE);
	eval 'sub WRC_CHIP () {2;}' unless defined(&WRC_CHIP);
	eval 'sub WRC_SYSTEM () {3;}' unless defined(&WRC_SYSTEM);
	eval 'sub TCR_WIE () {0x8000000;}' unless defined(&TCR_WIE);
	eval 'sub TCR_PIE () {0x4000000;}' unless defined(&TCR_PIE);
	eval 'sub TCR_DIE () { &TCR_PIE;}' unless defined(&TCR_DIE);
	eval 'sub TCR_FP {
	    my($x) = @_;
    	    eval q(((($x)&0x3)<<24));
	}' unless defined(&TCR_FP);
	eval 'sub FP_2_9 () {0;}' unless defined(&FP_2_9);
	eval 'sub FP_2_13 () {1;}' unless defined(&FP_2_13);
	eval 'sub FP_2_17 () {2;}' unless defined(&FP_2_17);
	eval 'sub FP_2_21 () {3;}' unless defined(&FP_2_21);
	eval 'sub TCR_FIE () {0x800000;}' unless defined(&TCR_FIE);
	eval 'sub TCR_ARE () {0x400000;}' unless defined(&TCR_ARE);
	eval 'sub SPRN_THRM1 () {0x3fc;}' unless defined(&SPRN_THRM1);
	eval 'sub THRM1_TIN () {(1<< 31);}' unless defined(&THRM1_TIN);
	eval 'sub THRM1_TIV () {(1<< 30);}' unless defined(&THRM1_TIV);
	eval 'sub THRM1_THRES {
	    my($x) = @_;
    	    eval q((($x&0x7f)<<23));
	}' unless defined(&THRM1_THRES);
	eval 'sub THRM3_SITV {
	    my($x) = @_;
    	    eval q((($x&0x3fff)<<1));
	}' unless defined(&THRM3_SITV);
	eval 'sub THRM1_TID () {(1<<2);}' unless defined(&THRM1_TID);
	eval 'sub THRM1_TIE () {(1<<1);}' unless defined(&THRM1_TIE);
	eval 'sub THRM1_V () {(1<<0);}' unless defined(&THRM1_V);
	eval 'sub SPRN_THRM2 () {0x3fd;}' unless defined(&SPRN_THRM2);
	eval 'sub SPRN_THRM3 () {0x3fe;}' unless defined(&SPRN_THRM3);
	eval 'sub THRM3_E () {(1<<0);}' unless defined(&THRM3_E);
	eval 'sub SPRN_TLBMISS () {0x3d4;}' unless defined(&SPRN_TLBMISS);
	if(defined(&CONFIG_BOOKE)) {
	    eval 'sub SPRN_TSR () {0x150;}' unless defined(&SPRN_TSR);
	} else {
	    eval 'sub SPRN_TSR () {0x3d8;}' unless defined(&SPRN_TSR);
	}
	eval 'sub TSR_ENW () {0x80000000;}' unless defined(&TSR_ENW);
	eval 'sub TSR_WIS () {0x40000000;}' unless defined(&TSR_WIS);
	eval 'sub TSR_WRS {
	    my($x) = @_;
    	    eval q(((($x)&0x3)<<28));
	}' unless defined(&TSR_WRS);
	eval 'sub WRS_NONE () {0;}' unless defined(&WRS_NONE);
	eval 'sub WRS_CORE () {1;}' unless defined(&WRS_CORE);
	eval 'sub WRS_CHIP () {2;}' unless defined(&WRS_CHIP);
	eval 'sub WRS_SYSTEM () {3;}' unless defined(&WRS_SYSTEM);
	eval 'sub TSR_PIS () {0x8000000;}' unless defined(&TSR_PIS);
	eval 'sub TSR_DIS () { &TSR_PIS;}' unless defined(&TSR_DIS);
	eval 'sub TSR_FIS () {0x4000000;}' unless defined(&TSR_FIS);
	eval 'sub SPRN_UMMCR0 () {0x3a8;}' unless defined(&SPRN_UMMCR0);
	eval 'sub SPRN_UMMCR1 () {0x3ac;}' unless defined(&SPRN_UMMCR1);
	eval 'sub SPRN_UPMC1 () {0x3a9;}' unless defined(&SPRN_UPMC1);
	eval 'sub SPRN_UPMC2 () {0x3aa;}' unless defined(&SPRN_UPMC2);
	eval 'sub SPRN_UPMC3 () {0x3ad;}' unless defined(&SPRN_UPMC3);
	eval 'sub SPRN_UPMC4 () {0x3ae;}' unless defined(&SPRN_UPMC4);
	eval 'sub SPRN_USIA () {0x3ab;}' unless defined(&SPRN_USIA);
	eval 'sub SPRN_VRSAVE () {0x100;}' unless defined(&SPRN_VRSAVE);
	eval 'sub SPRN_XER () {0x1;}' unless defined(&SPRN_XER);
	eval 'sub SPRN_ZPR () {0x3b0;}' unless defined(&SPRN_ZPR);
	eval 'sub SPRN_DECAR () {0x36;}' unless defined(&SPRN_DECAR);
	eval 'sub SPRN_CSRR0 () {0x3a;}' unless defined(&SPRN_CSRR0);
	eval 'sub SPRN_CSRR1 () {0x3b;}' unless defined(&SPRN_CSRR1);
	eval 'sub SPRN_IVPR () {0x3f;}' unless defined(&SPRN_IVPR);
	eval 'sub SPRN_USPRG0 () {0x100;}' unless defined(&SPRN_USPRG0);
	eval 'sub SPRN_SPRG4R () {0x104;}' unless defined(&SPRN_SPRG4R);
	eval 'sub SPRN_SPRG5R () {0x105;}' unless defined(&SPRN_SPRG5R);
	eval 'sub SPRN_SPRG6R () {0x106;}' unless defined(&SPRN_SPRG6R);
	eval 'sub SPRN_SPRG7R () {0x107;}' unless defined(&SPRN_SPRG7R);
	eval 'sub SPRN_SPRG4W () {0x114;}' unless defined(&SPRN_SPRG4W);
	eval 'sub SPRN_SPRG5W () {0x115;}' unless defined(&SPRN_SPRG5W);
	eval 'sub SPRN_SPRG6W () {0x116;}' unless defined(&SPRN_SPRG6W);
	eval 'sub SPRN_SPRG7W () {0x117;}' unless defined(&SPRN_SPRG7W);
	eval 'sub SPRN_DBCR2 () {0x136;}' unless defined(&SPRN_DBCR2);
	eval 'sub SPRN_IAC3 () {0x13a;}' unless defined(&SPRN_IAC3);
	eval 'sub SPRN_IAC4 () {0x13b;}' unless defined(&SPRN_IAC4);
	eval 'sub SPRN_DVC1 () {0x13e;}' unless defined(&SPRN_DVC1);
	eval 'sub SPRN_DVC2 () {0x13f;}' unless defined(&SPRN_DVC2);
	eval 'sub SPRN_IVOR0 () {0x190;}' unless defined(&SPRN_IVOR0);
	eval 'sub SPRN_IVOR1 () {0x191;}' unless defined(&SPRN_IVOR1);
	eval 'sub SPRN_IVOR2 () {0x192;}' unless defined(&SPRN_IVOR2);
	eval 'sub SPRN_IVOR3 () {0x193;}' unless defined(&SPRN_IVOR3);
	eval 'sub SPRN_IVOR4 () {0x194;}' unless defined(&SPRN_IVOR4);
	eval 'sub SPRN_IVOR5 () {0x195;}' unless defined(&SPRN_IVOR5);
	eval 'sub SPRN_IVOR6 () {0x196;}' unless defined(&SPRN_IVOR6);
	eval 'sub SPRN_IVOR7 () {0x197;}' unless defined(&SPRN_IVOR7);
	eval 'sub SPRN_IVOR8 () {0x198;}' unless defined(&SPRN_IVOR8);
	eval 'sub SPRN_IVOR9 () {0x199;}' unless defined(&SPRN_IVOR9);
	eval 'sub SPRN_IVOR10 () {0x19a;}' unless defined(&SPRN_IVOR10);
	eval 'sub SPRN_IVOR11 () {0x19b;}' unless defined(&SPRN_IVOR11);
	eval 'sub SPRN_IVOR12 () {0x19c;}' unless defined(&SPRN_IVOR12);
	eval 'sub SPRN_IVOR13 () {0x19d;}' unless defined(&SPRN_IVOR13);
	eval 'sub SPRN_IVOR14 () {0x19e;}' unless defined(&SPRN_IVOR14);
	eval 'sub SPRN_IVOR15 () {0x19f;}' unless defined(&SPRN_IVOR15);
	eval 'sub SPRN_MCSRR0 () {0x23a;}' unless defined(&SPRN_MCSRR0);
	eval 'sub SPRN_MCSRR1 () {0x23b;}' unless defined(&SPRN_MCSRR1);
	eval 'sub SPRN_MCSR () {0x23c;}' unless defined(&SPRN_MCSR);
	if(defined( &CONFIG_440A)) {
	    eval 'sub MCSR_MCS () {0x80000000;}' unless defined(&MCSR_MCS);
	    eval 'sub MCSR_IB () {0x40000000;}' unless defined(&MCSR_IB);
	    eval 'sub MCSR_DRB () {0x20000000;}' unless defined(&MCSR_DRB);
	    eval 'sub MCSR_DWB () {0x10000000;}' unless defined(&MCSR_DWB);
	    eval 'sub MCSR_TLBP () {0x8000000;}' unless defined(&MCSR_TLBP);
	    eval 'sub MCSR_ICP () {0x4000000;}' unless defined(&MCSR_ICP);
	    eval 'sub MCSR_DCSP () {0x2000000;}' unless defined(&MCSR_DCSP);
	    eval 'sub MCSR_DCFP () {0x1000000;}' unless defined(&MCSR_DCFP);
	    eval 'sub MCSR_IMPE () {0x800000;}' unless defined(&MCSR_IMPE);
	}
	eval 'sub SPRN_MMUCR () {0x3b2;}' unless defined(&SPRN_MMUCR);
	eval 'sub CTR () { &SPRN_CTR;}' unless defined(&CTR);
	eval 'sub DAR () { &SPRN_DAR;}' unless defined(&DAR);
	eval 'sub DABR () { &SPRN_DABR;}' unless defined(&DABR);
	eval 'sub DBAT0L () { &SPRN_DBAT0L;}' unless defined(&DBAT0L);
	eval 'sub DBAT0U () { &SPRN_DBAT0U;}' unless defined(&DBAT0U);
	eval 'sub DBAT1L () { &SPRN_DBAT1L;}' unless defined(&DBAT1L);
	eval 'sub DBAT1U () { &SPRN_DBAT1U;}' unless defined(&DBAT1U);
	eval 'sub DBAT2L () { &SPRN_DBAT2L;}' unless defined(&DBAT2L);
	eval 'sub DBAT2U () { &SPRN_DBAT2U;}' unless defined(&DBAT2U);
	eval 'sub DBAT3L () { &SPRN_DBAT3L;}' unless defined(&DBAT3L);
	eval 'sub DBAT3U () { &SPRN_DBAT3U;}' unless defined(&DBAT3U);
	eval 'sub DBAT4L () { &SPRN_DBAT4L;}' unless defined(&DBAT4L);
	eval 'sub DBAT4U () { &SPRN_DBAT4U;}' unless defined(&DBAT4U);
	eval 'sub DBAT5L () { &SPRN_DBAT5L;}' unless defined(&DBAT5L);
	eval 'sub DBAT5U () { &SPRN_DBAT5U;}' unless defined(&DBAT5U);
	eval 'sub DBAT6L () { &SPRN_DBAT6L;}' unless defined(&DBAT6L);
	eval 'sub DBAT6U () { &SPRN_DBAT6U;}' unless defined(&DBAT6U);
	eval 'sub DBAT7L () { &SPRN_DBAT7L;}' unless defined(&DBAT7L);
	eval 'sub DBAT7U () { &SPRN_DBAT7U;}' unless defined(&DBAT7U);
	eval 'sub DCMP () { &SPRN_DCMP;}' unless defined(&DCMP);
	eval 'sub DEC () { &SPRN_DEC;}' unless defined(&DEC);
	eval 'sub DECAR () { &SPRN_DECAR;}' unless defined(&DECAR);
	eval 'sub DMISS () { &SPRN_DMISS;}' unless defined(&DMISS);
	eval 'sub DSISR () { &SPRN_DSISR;}' unless defined(&DSISR);
	eval 'sub EAR () { &SPRN_EAR;}' unless defined(&EAR);
	eval 'sub HASH1 () { &SPRN_HASH1;}' unless defined(&HASH1);
	eval 'sub HASH2 () { &SPRN_HASH2;}' unless defined(&HASH2);
	eval 'sub HID0 () { &SPRN_HID0;}' unless defined(&HID0);
	eval 'sub HID1 () { &SPRN_HID1;}' unless defined(&HID1);
	eval 'sub IABR () { &SPRN_IABR;}' unless defined(&IABR);
	eval 'sub IBAT0L () { &SPRN_IBAT0L;}' unless defined(&IBAT0L);
	eval 'sub IBAT0U () { &SPRN_IBAT0U;}' unless defined(&IBAT0U);
	eval 'sub IBAT1L () { &SPRN_IBAT1L;}' unless defined(&IBAT1L);
	eval 'sub IBAT1U () { &SPRN_IBAT1U;}' unless defined(&IBAT1U);
	eval 'sub IBAT2L () { &SPRN_IBAT2L;}' unless defined(&IBAT2L);
	eval 'sub IBAT2U () { &SPRN_IBAT2U;}' unless defined(&IBAT2U);
	eval 'sub IBAT3L () { &SPRN_IBAT3L;}' unless defined(&IBAT3L);
	eval 'sub IBAT3U () { &SPRN_IBAT3U;}' unless defined(&IBAT3U);
	eval 'sub IBAT4L () { &SPRN_IBAT4L;}' unless defined(&IBAT4L);
	eval 'sub IBAT4U () { &SPRN_IBAT4U;}' unless defined(&IBAT4U);
	eval 'sub IBAT5L () { &SPRN_IBAT5L;}' unless defined(&IBAT5L);
	eval 'sub IBAT5U () { &SPRN_IBAT5U;}' unless defined(&IBAT5U);
	eval 'sub IBAT6L () { &SPRN_IBAT6L;}' unless defined(&IBAT6L);
	eval 'sub IBAT6U () { &SPRN_IBAT6U;}' unless defined(&IBAT6U);
	eval 'sub IBAT7L () { &SPRN_IBAT7L;}' unless defined(&IBAT7L);
	eval 'sub IBAT7U () { &SPRN_IBAT7U;}' unless defined(&IBAT7U);
	eval 'sub ICMP () { &SPRN_ICMP;}' unless defined(&ICMP);
	eval 'sub IMISS () { &SPRN_IMISS;}' unless defined(&IMISS);
	eval 'sub IMMR () { &SPRN_IMMR;}' unless defined(&IMMR);
	eval 'sub L2CR () { &SPRN_L2CR;}' unless defined(&L2CR);
	eval 'sub L3CR () { &SPRN_L3CR;}' unless defined(&L3CR);
	eval 'sub LR () { &SPRN_LR;}' unless defined(&LR);
	eval 'sub PVR () { &SPRN_PVR;}' unless defined(&PVR);
	eval 'sub RPA () { &SPRN_RPA;}' unless defined(&RPA);
	eval 'sub SDR1 () { &SPRN_SDR1;}' unless defined(&SDR1);
	eval 'sub USPRG0 () { &SPRN_USPRG0;}' unless defined(&USPRG0);
	eval 'sub SPR0 () { &SPRN_SPRG0;}' unless defined(&SPR0);
	eval 'sub SPR1 () { &SPRN_SPRG1;}' unless defined(&SPR1);
	eval 'sub SPR2 () { &SPRN_SPRG2;}' unless defined(&SPR2);
	eval 'sub SPR3 () { &SPRN_SPRG3;}' unless defined(&SPR3);
	eval 'sub SPR4 () { &SPRN_SPRG4;}' unless defined(&SPR4);
	eval 'sub SPR5 () { &SPRN_SPRG5;}' unless defined(&SPR5);
	eval 'sub SPR6 () { &SPRN_SPRG6;}' unless defined(&SPR6);
	eval 'sub SPR7 () { &SPRN_SPRG7;}' unless defined(&SPR7);
	eval 'sub SPRG0 () { &SPRN_SPRG0;}' unless defined(&SPRG0);
	eval 'sub SPRG1 () { &SPRN_SPRG1;}' unless defined(&SPRG1);
	eval 'sub SPRG2 () { &SPRN_SPRG2;}' unless defined(&SPRG2);
	eval 'sub SPRG3 () { &SPRN_SPRG3;}' unless defined(&SPRG3);
	eval 'sub SPRG4 () { &SPRN_SPRG4;}' unless defined(&SPRG4);
	eval 'sub SPRG5 () { &SPRN_SPRG5;}' unless defined(&SPRG5);
	eval 'sub SPRG6 () { &SPRN_SPRG6;}' unless defined(&SPRG6);
	eval 'sub SPRG7 () { &SPRN_SPRG7;}' unless defined(&SPRG7);
	eval 'sub SRR0 () { &SPRN_SRR0;}' unless defined(&SRR0);
	eval 'sub SRR1 () { &SPRN_SRR1;}' unless defined(&SRR1);
	eval 'sub TBRL () { &SPRN_TBRL;}' unless defined(&TBRL);
	eval 'sub TBRU () { &SPRN_TBRU;}' unless defined(&TBRU);
	eval 'sub TBWL () { &SPRN_TBWL;}' unless defined(&TBWL);
	eval 'sub TBWU () { &SPRN_TBWU;}' unless defined(&TBWU);
	eval 'sub ICTC () {1019;}' unless defined(&ICTC);
	eval 'sub THRM1 () { &SPRN_THRM1;}' unless defined(&THRM1);
	eval 'sub THRM2 () { &SPRN_THRM2;}' unless defined(&THRM2);
	eval 'sub THRM3 () { &SPRN_THRM3;}' unless defined(&THRM3);
	eval 'sub XER () { &SPRN_XER;}' unless defined(&XER);
	eval 'sub PVR_VER {
	    my($pvr) = @_;
    	    eval q(((($pvr) >> 16) & 0xffff));
	}' unless defined(&PVR_VER);
	eval 'sub PVR_REV {
	    my($pvr) = @_;
    	    eval q(((($pvr) >> 0) & 0xffff));
	}' unless defined(&PVR_REV);
	eval 'sub PVR_FAM {
	    my($pvr) = @_;
    	    eval q(((($pvr) >> 20) & 0xfff));
	}' unless defined(&PVR_FAM);
	eval 'sub PVR_MEM {
	    my($pvr) = @_;
    	    eval q(((($pvr) >> 16) & 0xf));
	}' unless defined(&PVR_MEM);
	eval 'sub PVR_CORE {
	    my($pvr) = @_;
    	    eval q(((($pvr) >> 12) & 0xf));
	}' unless defined(&PVR_CORE);
	eval 'sub PVR_CFG {
	    my($pvr) = @_;
    	    eval q(((($pvr) >> 8) & 0xf));
	}' unless defined(&PVR_CFG);
	eval 'sub PVR_MAJ {
	    my($pvr) = @_;
    	    eval q(((($pvr) >> 4) & 0xf));
	}' unless defined(&PVR_MAJ);
	eval 'sub PVR_MIN {
	    my($pvr) = @_;
    	    eval q(((($pvr) >> 0) & 0xf));
	}' unless defined(&PVR_MIN);
	eval 'sub PVR_403GA () {0x200000;}' unless defined(&PVR_403GA);
	eval 'sub PVR_403GB () {0x200100;}' unless defined(&PVR_403GB);
	eval 'sub PVR_403GC () {0x200200;}' unless defined(&PVR_403GC);
	eval 'sub PVR_403GCX () {0x201400;}' unless defined(&PVR_403GCX);
	eval 'sub PVR_405GP () {0x40110000;}' unless defined(&PVR_405GP);
	eval 'sub PVR_STB03XXX () {0x40310000;}' unless defined(&PVR_STB03XXX);
	eval 'sub PVR_440GP_RB () {0x40120440;}' unless defined(&PVR_440GP_RB);
	eval 'sub PVR_440GP_RC1 () {0x40120481;}' unless defined(&PVR_440GP_RC1);
	eval 'sub PVR_440GP_RC2 () {0x40200481;}' unless defined(&PVR_440GP_RC2);
	eval 'sub PVR_440GX_RA () {0x51b21850;}' unless defined(&PVR_440GX_RA);
	eval 'sub PVR_440GX_RB () {0x51b21851;}' unless defined(&PVR_440GX_RB);
	eval 'sub PVR_440GX_RB1 () {0x51b21852;}' unless defined(&PVR_440GX_RB1);
	eval 'sub PVR_601 () {0x10000;}' unless defined(&PVR_601);
	eval 'sub PVR_602 () {0x50000;}' unless defined(&PVR_602);
	eval 'sub PVR_603 () {0x30000;}' unless defined(&PVR_603);
	eval 'sub PVR_603e () {0x60000;}' unless defined(&PVR_603e);
	eval 'sub PVR_603ev () {0x70000;}' unless defined(&PVR_603ev);
	eval 'sub PVR_603r () {0x71000;}' unless defined(&PVR_603r);
	eval 'sub PVR_604 () {0x40000;}' unless defined(&PVR_604);
	eval 'sub PVR_604e () {0x90000;}' unless defined(&PVR_604e);
	eval 'sub PVR_604r () {0xa0000;}' unless defined(&PVR_604r);
	eval 'sub PVR_620 () {0x140000;}' unless defined(&PVR_620);
	eval 'sub PVR_740 () {0x80000;}' unless defined(&PVR_740);
	eval 'sub PVR_750 () { &PVR_740;}' unless defined(&PVR_750);
	eval 'sub PVR_740P () {0x10080000;}' unless defined(&PVR_740P);
	eval 'sub PVR_750P () { &PVR_740P;}' unless defined(&PVR_750P);
	eval 'sub PVR_7400 () {0xc0000;}' unless defined(&PVR_7400);
	eval 'sub PVR_7410 () {0x800c0000;}' unless defined(&PVR_7410);
	eval 'sub PVR_7450 () {0x80000000;}' unless defined(&PVR_7450);
	eval 'sub PVR_821 () {0x500000;}' unless defined(&PVR_821);
	eval 'sub PVR_823 () { &PVR_821;}' unless defined(&PVR_823);
	eval 'sub PVR_850 () { &PVR_821;}' unless defined(&PVR_850);
	eval 'sub PVR_860 () { &PVR_821;}' unless defined(&PVR_860);
	eval 'sub PVR_8240 () {0x810100;}' unless defined(&PVR_8240);
	eval 'sub PVR_8260 () { &PVR_8240;}' unless defined(&PVR_8260);
	eval 'sub _MACH_prep () {0x1;}' unless defined(&_MACH_prep);
	eval 'sub _MACH_Pmac () {0x2;}' unless defined(&_MACH_Pmac);
	eval 'sub _MACH_chrp () {0x4;}' unless defined(&_MACH_chrp);
	eval 'sub _PREP_Motorola () {0x1;}' unless defined(&_PREP_Motorola);
	eval 'sub _PREP_Firm () {0x2;}' unless defined(&_PREP_Firm);
	eval 'sub _PREP_IBM () {0x;}' unless defined(&_PREP_IBM);
	eval 'sub _PREP_Bull () {0x3;}' unless defined(&_PREP_Bull);
	eval 'sub _CHRP_Motorola () {0x4;}' unless defined(&_CHRP_Motorola);
	eval 'sub _CHRP_IBM () {0x5;}' unless defined(&_CHRP_IBM);
	eval 'sub _GLOBAL {
	    my($n) = @_;
    	    eval q(. &stabs  &__stringify($n: &F-1), &N_FUN,0,0,$n; . &globl $n;$n:);
	}' unless defined(&_GLOBAL);
	eval 'sub mfdcr {
	    my($rn) = @_;
    	    eval q(({\'unsigned int rval\';  &asm  &volatile(\\"mfdcr %0,\\"  &__stringify($rn) : \\"=r\\" ( &rval));  &rval;}));
	}' unless defined(&mfdcr);
	eval 'sub mtdcr {
	    my($rn, $v) = @_;
    	    eval q( &asm  &volatile(\\"mtdcr \\"  &__stringify($rn) \\",%0\\" : : \\"r\\" ($v)));
	}' unless defined(&mtdcr);
	eval 'sub mfmsr () {
	    eval q(({\'unsigned int rval\';  &asm  &volatile(\\"mfmsr %0\\" : \\"=r\\" ( &rval));  &rval;}));
	}' unless defined(&mfmsr);
	eval 'sub mtmsr {
	    my($v) = @_;
    	    eval q( &asm  &volatile(\\"mtmsr %0\\" : : \\"r\\" ($v)));
	}' unless defined(&mtmsr);
	eval 'sub mfspr {
	    my($rn) = @_;
    	    eval q(({\'unsigned int rval\';  &asm  &volatile(\\"mfspr %0,\\"  &__stringify($rn) : \\"=r\\" ( &rval));  &rval;}));
	}' unless defined(&mfspr);
	eval 'sub mtspr {
	    my($rn, $v) = @_;
    	    eval q( &asm  &volatile(\\"mtspr \\"  &__stringify($rn) \\",%0\\" : : \\"r\\" ($v)));
	}' unless defined(&mtspr);
	eval 'sub SR0 () {0;}' unless defined(&SR0);
	eval 'sub SR1 () {1;}' unless defined(&SR1);
	eval 'sub SR2 () {2;}' unless defined(&SR2);
	eval 'sub SR3 () {3;}' unless defined(&SR3);
	eval 'sub SR4 () {4;}' unless defined(&SR4);
	eval 'sub SR5 () {5;}' unless defined(&SR5);
	eval 'sub SR6 () {6;}' unless defined(&SR6);
	eval 'sub SR7 () {7;}' unless defined(&SR7);
	eval 'sub SR8 () {8;}' unless defined(&SR8);
	eval 'sub SR9 () {9;}' unless defined(&SR9);
	eval 'sub SR10 () {10;}' unless defined(&SR10);
	eval 'sub SR11 () {11;}' unless defined(&SR11);
	eval 'sub SR12 () {12;}' unless defined(&SR12);
	eval 'sub SR13 () {13;}' unless defined(&SR13);
	eval 'sub SR14 () {14;}' unless defined(&SR14);
	eval 'sub SR15 () {15;}' unless defined(&SR15);
	unless(defined(&__ASSEMBLY__)) {
	    if(defined( &CONFIG_ALL_PPC)) {
	    } else {
		eval 'sub _machine () {0;}' unless defined(&_machine);
	    }
	    eval 'sub EISA_bus () {0;}' unless defined(&EISA_bus);
	    eval 'sub EISA_bus__is_a_macro () {1;}' unless defined(&EISA_bus__is_a_macro);
	    eval 'sub MCA_bus () {0;}' unless defined(&MCA_bus);
	    eval 'sub MCA_bus__is_a_macro () {1;}' unless defined(&MCA_bus__is_a_macro);
	    eval 'sub TASK_SIZE () { &CONFIG_TASK_SIZE;}' unless defined(&TASK_SIZE);
	    eval 'sub TASK_UNMAPPED_BASE () {( &TASK_SIZE / 8* 3);}' unless defined(&TASK_UNMAPPED_BASE);
	    if(defined(&CONFIG_ALTIVEC)) {
	    }
	    if(defined( &CONFIG_4xx)) {
	    }
	    eval 'sub INIT_SP () {($sizeof{ &init_stack} +   &init_stack);}' unless defined(&INIT_SP);
	    eval 'sub INIT_THREAD () {{ . &ksp =  &INIT_SP, . &fs =  &KERNEL_DS, . &pgdir =  &swapper_pg_dir, . &fpexc_mode =  &MSR_FE0 |  &MSR_FE1, };}' unless defined(&INIT_THREAD);
	    eval 'sub copy_segments {
	        my($tsk, $mm) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&copy_segments);
	    eval 'sub release_segments {
	        my($mm) = @_;
    		eval q( &do { }  &while (0));
	    }' unless defined(&release_segments);
	    eval 'sub KSTK_EIP {
	        my($tsk) = @_;
    		eval q((($tsk)-> ($thread->{regs})? ($tsk)-> ($thread->{regs}->{nip}): 0));
	    }' unless defined(&KSTK_EIP);
	    eval 'sub KSTK_ESP {
	        my($tsk) = @_;
    		eval q((($tsk)-> ($thread->{regs})? ($tsk)-> ($thread->{regs}->{gpr[1]}): 0));
	    }' unless defined(&KSTK_ESP);
	    eval 'sub GET_FPEXC_CTL {
	        my($tsk, $adr) = @_;
    		eval q( &get_fpexc_mode(($tsk), ($adr)));
	    }' unless defined(&GET_FPEXC_CTL);
	    eval 'sub SET_FPEXC_CTL {
	        my($tsk, $val) = @_;
    		eval q( &set_fpexc_mode(($tsk), ($val)));
	    }' unless defined(&SET_FPEXC_CTL);
	    eval 'sub THREAD_SIZE () {(2* &PAGE_SIZE);}' unless defined(&THREAD_SIZE);
	    eval 'sub alloc_task_struct () {
	        eval q((  &__get_free_pages( &GFP_KERNEL,1)));
	    }' unless defined(&alloc_task_struct);
	    eval 'sub free_task_struct {
	        my($p) = @_;
    		eval q( &free_pages(($p),1));
	    }' unless defined(&free_task_struct);
	    eval 'sub get_task_struct {
	        my($tsk) = @_;
    		eval q( &atomic_inc( &virt_to_page($tsk)-> &count));
	    }' unless defined(&get_task_struct);
	    eval 'sub init_task () {( ($init_task_union->{task}));}' unless defined(&init_task);
	    eval 'sub init_stack () {( ($init_task_union->{stack}));}' unless defined(&init_stack);
	    eval 'sub cpu_relax () {
	        eval q( &do { }  &while (0));
	    }' unless defined(&cpu_relax);
	    eval 'sub ARCH_HAS_PREFETCH () {1;}' unless defined(&ARCH_HAS_PREFETCH);
	    eval 'sub ARCH_HAS_PREFETCHW () {1;}' unless defined(&ARCH_HAS_PREFETCHW);
	    eval 'sub ARCH_HAS_SPINLOCK_PREFETCH () {1;}' unless defined(&ARCH_HAS_SPINLOCK_PREFETCH);
	    eval 'sub spin_lock_prefetch {
	        my($x) = @_;
    		eval q( &prefetchw($x));
	    }' unless defined(&spin_lock_prefetch);
	}
	eval 'sub have_of () {( &_machine ==  &_MACH_chrp ||  &_machine ==  &_MACH_Pmac);}' unless defined(&have_of);
    }
}
1;
